package com.yutou.controller;

import java.util.Date;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import com.yutou.utlis.Log;
import org.json.JSONObject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.yutou.mybatis.UUserGameData;
import com.yutou.mybatis.UUserdata;
import com.yutou.services.UserService;
import com.yutou.utlis.QiniuTools;
import com.yutou.utlis.RedisUtlis;
import com.yutou.utlis.Tools;

@RequestMapping("/cdn")
@Controller
public class CDNController {
	@Resource
	UserService user;

	@RequestMapping("/ballback.do")
	@ResponseBody
	public String ballback(HttpServletRequest request, String hash, String key, String bucket, String fsize,
			String uuid, String uToken,String qToken) {
		try {
			Log.i("七牛云回调:");
			Tools.PrintfHttpServletRequest(request);
			if (qToken == null) {
				JSONObject json = new JSONObject();
				json.put("success", true);
				json.put("name", key);
				return json.toString();
			}
			JSONObject ujson = new JSONObject(RedisUtlis.get(uToken));
			UUserGameData gameData = user.findGameData(ujson.getInt("uid"), key);
			UUserdata udata=user.getUUserData(ujson.getInt("uid"));
			String type=RedisUtlis.get(qToken);
			if ((ujson.getInt("uid") + "").equals(uuid)) {
				switch (type) {
				case "gamedata":
					if (gameData == null) {
						gameData = new UUserGameData();
						gameData.setFile(key);
						gameData.setHash(hash);
						gameData.setUid(ujson.getInt("uid"));
						gameData.setFsize(fsize);
						gameData.setCreatetime(new Date());
						gameData.setUpdatetime(new Date());
						gameData.setUpindex(1);
						user.addGameData(gameData);
					} else {
						gameData.setFile(key);
						gameData.setHash(hash);
						gameData.setUid(ujson.getInt("uid"));
						gameData.setFsize(fsize);
						gameData.setUpdatetime(new Date());
						gameData.setUpindex(gameData.getUpindex() + 1);
						user.updateGameData(gameData);
					}
					int tmp=(int) (Long.parseLong(fsize) / 1024 / 1024);
					if(tmp<=0) {
						tmp=1;
					}
					udata.setCredit(udata.getCredit() - tmp);
					user.updateUserData(udata);
					break;
				case "uimg":
					udata.setImage("http://hzcdn.jianrmod.cn/"+key);
					user.updateUserData(udata);
					break;
				default:
					break;
				}
			}
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
			// 这里可能需要做删除文件操作
			QiniuTools.init().delete(key);
		}
		JSONObject json = new JSONObject();
		json.put("success", true);
		json.put("name", key);
		return json.toString();
	}
}
