package com.yutou.controller.MapTop;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.yutou.enums.UserEnum;
import com.yutou.jianrdb.Bean.GameInfoLog;
import com.yutou.jianrdb.Bean.MapNode;
import com.yutou.jianrdb.Mapper.MapNodeService;
import com.yutou.maptop.Bean.MapTop;
import com.yutou.maptop.Bean.UserTeam;
import com.yutou.maptop.services.MapTopService;
import com.yutou.maptop.services.UserTeamService;
import com.yutou.mybatis.ZsShipType;
import com.yutou.mybatis.ZsShipTypeExample;
import com.yutou.mybatis.dao.ZsShipTypeMapper;
import com.yutou.utlis.Tools;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;
import java.util.List;

@Controller
public class AndroidMapController {

    @Resource
    MapNodeService mapNodeService;
    @Resource
    ZsShipTypeMapper jianTypeMapper;

    /**
     * 全部数据
     */
    @ResponseBody
    @RequestMapping("/android/map/all.do")
    public String getMap(HttpServletRequest request){

        JSONObject json=new JSONObject();
        if(Tools.getUidOfToken(request)<=0){
            json.put("msg",UserEnum.LOGIN_NOT_LOGIN.msg);
            json.put("code", UserEnum.LOGIN_NOT_LOGIN.code);
            return json.toString();
        }

        List<String> list=mapNodeService.selectMapName();
        json.put("count",list.size());
        json.put("data", JSONArray.toJSON(list));

        return  json.toJSONString();
    }

    @ResponseBody
    @RequestMapping("/android/map/node.do")
    public String getMapNode(HttpServletRequest request,String levelName){
        JSONObject json=new JSONObject();
        if(Tools.getUidOfToken(request)<=0){
            json.put("msg",UserEnum.LOGIN_NOT_LOGIN.msg);
            json.put("code", UserEnum.LOGIN_NOT_LOGIN.code);
            return json.toString();
        }

        List<String> list=mapNodeService.selectNodeName(levelName);
        json.put("count",list.size());
        json.put("data", JSONArray.toJSON(list));
        return  json.toJSONString();
    }
    @ResponseBody
    @RequestMapping("/android/map/data.do")
    public String getMapData(HttpServletRequest request,String chapterName, String levelName){
        JSONObject json=new JSONObject();
        if(Tools.getUidOfToken(request)<=0){
            json.put("msg",UserEnum.LOGIN_NOT_LOGIN.msg);
            json.put("code", UserEnum.LOGIN_NOT_LOGIN.code);
            return json.toString();
        }

        List<MapNode> list=mapNodeService.selectMapByNode(chapterName, levelName);
        json.put("count",list.size());
        json.put("data", JSONArray.toJSON(list));
        return  json.toJSONString();
    }
    @ResponseBody
    @RequestMapping("/android/map/team/data.do")
    public String getTeamByMapNodeAndLike(HttpServletRequest request,int node,int limit,String likeArray){
        JSONObject json=new JSONObject();
        if(Tools.getUidOfToken(request)<=0){
            json.put("msg",UserEnum.LOGIN_NOT_LOGIN.msg);
            json.put("code", UserEnum.LOGIN_NOT_LOGIN.code);
            return json.toString();
        }

        int count=50;
        List<GameInfoLog> list=mapNodeService.selectNodeByMid(node,limit,count);
        json.put("count",list.size());
        json.put("data", JSONArray.toJSON(list));
        if(list.size()==count){
            json.put("next",true);
        }else{
            json.put("next",false);
        }
        return  json.toJSONString();
    }
    @ResponseBody
    @RequestMapping("/android/ship/type.do")
    public String getShipType(HttpServletRequest request){
        JSONObject json=new JSONObject();
        List<ZsShipType> list=mapNodeService.selectAllShipType();
        json.put("count",list.size());
        json.put("data", JSONArray.toJSON(list));
        return  json.toJSONString();
    }
}
