package com.yutou.controller.MapTop;

import com.alibaba.fastjson.JSONObject;
import com.yutou.enums.UserEnum;
import com.yutou.jianrdb.Bean.GameInfoLog;
import com.yutou.jianrdb.Mapper.GameInfoLogService;
import com.yutou.maptop.Bean.MapTop;
import com.yutou.maptop.Bean.UserTeam;
import com.yutou.maptop.services.MapTopService;
import com.yutou.maptop.services.UserTeamService;
import com.yutou.utlis.JianrDataTools;
import com.yutou.utlis.Log;
import com.yutou.utlis.Tools;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Locale;

@Controller
public class MapTopController {
    @Resource
    GameInfoLogService gameInfoLogService;
    @Resource
    UserTeamService userTeamService;
    @Resource
    MapTopService mapTopService;

    @ResponseBody
    @RequestMapping("/map/update.do")
    public String updateMapTop(String key) {
        if(!"2LwK8xlmMXiMR22ru6WriR9eBllePWWYUVqrS4G5jOPWg8jGtt76gsZPi41yUTpe".equals(key)){
            return "";
        }
        updateMap();
        return "ok";
    }


    private void updateMap() {
        List<GameInfoLog> list = gameInfoLogService.getGameInfoLogByType("DealNode", 1, 500);
        tcapprocessData(list);
        Tools.getHTTPUrlString("https://sc.ftqq.com/SCU64034T5adf5c5940dcecc016e0e9d0cf9b1e725da126ff47475.send?text=盒子更新MAP数据&desp=成功更新500条数据"+new SimpleDateFormat("yyyy-MM-dd HH:mm:ss", Locale.CHINA).format(new Date()));
    }

    private void tcapprocessData(List<GameInfoLog> list) {
        for (GameInfoLog gameInfoLog : list) {
            try {
                if(!JSONObject.parseObject(gameInfoLog.getExt()).getString("s").equals("pve")){
                    continue;
                }
                if (!userTeamService.checkData(gameInfoLog.getUsername(), JianrDataTools.getMapNode(gameInfoLog.getExt()), JianrDataTools.getShip(JSONObject.parseObject(gameInfoLog.getMessage()),JianrDataTools.SHIP_TITLE))) {
                    MapTop map = new MapTop();
                    map.setMapid(JianrDataTools.getMapId(gameInfoLog.getExt()));
                    map.setMapNode(JianrDataTools.getMapNode(gameInfoLog.getExt()));
                    map.setShipTeam(JianrDataTools.getShip(JSONObject.parseObject(gameInfoLog.getMessage()),JianrDataTools.SHIP_TYPE));
                    int id=mapTopService.insertMapTop(map);
                    Log.i(">>>>>>ID="+id+"  ---> "+JSONObject.parseObject(gameInfoLog.getExt()).getInteger("n")+"   "+gameInfoLog.getId());
                    UserTeam team=new UserTeam();
                    team.setMid(id);
                    team.setMapNode(map.getMapNode());
                    team.setUname(gameInfoLog.getUsername());
                    team.setShip(JianrDataTools.getShip(JSONObject.parseObject(gameInfoLog.getMessage())).toString());
                    team.setTitle(JianrDataTools.getShip(JSONObject.parseObject(gameInfoLog.getMessage()),JianrDataTools.SHIP_TITLE));
                    team.setCreateTime(gameInfoLog.getClient_time());
                    userTeamService.insertTeam(team);
                }
            }catch (Exception e){
                e.printStackTrace();
                System.exit(0);
            }

        }
    }
}
