package com.yutou.controller;

import java.util.List;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import org.json.JSONObject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import com.alibaba.fastjson.JSON;
import com.yutou.enums.ModEnum;
import com.yutou.mybatis.TModfilePath;
import com.yutou.services.ModService;
import com.yutou.utlis.Tools;

@RequestMapping("utlis")
@Controller
public class UtlisController {
	@Resource
	ModService modService;

	@RequestMapping("/installPath.do")
	@ResponseBody
	public String getInstallPath(HttpServletRequest request) {
		List<TModfilePath> paths=modService.getInstallPaths();
		JSONObject json=new JSONObject();
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(paths));
		return json.toString();
	}
	@RequestMapping("/upload.do")
	@ResponseBody
	public String uploadFile(HttpServletRequest request,MultipartFile file) {
		JSONObject json=new JSONObject();
		try {
			json.put("code", 0);
			json.put("file", Tools.createFile(request, "tmp/", file, null));
			json.put("msg", "ok");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			json.put("code", -1);
			json.put("file", "");
			json.put("msg", e.getMessage());
		}
		return json.toString();
	}
}
