package com.yutou.controller.Web;


import java.nio.charset.StandardCharsets;
import java.text.SimpleDateFormat;

import javax.annotation.Resource;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.yutou.utlis.Log;
import org.json.JSONObject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.yutou.enums.UserEnum;
import com.yutou.enums.UserPower;
import com.yutou.mybatis.UGroup;
import com.yutou.mybatis.User;
import com.yutou.services.PermissionService;
import com.yutou.services.UserService;
import com.yutou.utlis.RedisUtlis;
import com.yutou.utlis.Tools;

@Controller
public class WebLoginController {
	@Resource
	UserService userService;
	@Resource
	PermissionService permissionService;

	@RequestMapping("/user/login.do")
	@ResponseBody
	public String login(HttpServletRequest request, HttpServletResponse response) {
		String uname = request.getParameter("uname");
		String pass = request.getParameter("pass");
		JSONObject json = new JSONObject();
		if (Tools.StringIsEmpty(uname, pass)) {
			json.put("msg", UserEnum.ACCOUNT_OR_PASSWORD_NOT.msg);
			json.put("code", UserEnum.ACCOUNT_OR_PASSWORD_NOT.code);
			return json.toString();
		}
		int str = userService.login(uname, pass);
		json.put("id", str);
		json.put("name", uname);
		switch (str) {
		case -2:
			json.put("msg", UserEnum.ACCOUNT_OR_PASSWORD_ERROR.msg);
			json.put("code", UserEnum.ACCOUNT_OR_PASSWORD_ERROR.code);
			break;
		case -1:
			json.put("msg", UserEnum.LOGIN_NOT_REG.msg);
			json.put("code", UserEnum.LOGIN_NOT_REG.code);
			break;
		case -3:
			json.put("msg", UserEnum.LOGIN_BEAN.msg+""+new SimpleDateFormat("yyyy年MM月DD日 HH时mm分ss秒").format(userService.getUUserData(userService.getUserId(uname)).getUnbeantime()));
			json.put("code", UserEnum.LOGIN_BEAN.code);
			break;
		case -4:
			json.put("msg", UserEnum.LOGIN_blacklist.msg);
			json.put("code", UserEnum.LOGIN_blacklist.code);
			break;
		default:
			json.put("msg", UserEnum.LOGIN_SUCCESS.msg);
			json.put("code", UserEnum.LOGIN_SUCCESS.code);
			json.put("id", str);
			json.put("uid", str);

			/*Tools.saveSession(request, request.getSession().getId(), str);*/
			String token=Tools.getToken(request,str);
			Cookie cookie=new Cookie("login",token);
			cookie.setPath("/");
			response.addCookie(cookie);
			json.put("token",token);
			RedisUtlis.set(token,json.toString());
			request.getSession().setAttribute("power", 100);
			break;
		}
		Log.i(json.toString());
		return json.toString();
	}

	@RequestMapping("/user/reg.do")
	@ResponseBody
	public String reg(HttpServletRequest request,String uname,String pass,String name) {
		JSONObject json = new JSONObject();
		Log.i("注册请求");
		Tools.PrintfHttpServletRequest(request);
		try {
			uname=new String(uname.getBytes(), StandardCharsets.UTF_8);
			pass=new String(pass.getBytes(), StandardCharsets.UTF_8);
			name=new String(name.getBytes(), StandardCharsets.UTF_8);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if (Tools.StringIsEmpty(uname, pass)) {
			json.put("msg", UserEnum.ACCOUNT_OR_PASSWORD_NOT.msg);
			json.put("code", UserEnum.ACCOUNT_OR_PASSWORD_NOT.code);
			return json.toString();
		}
		int str = userService.reg(name,uname, pass);
		if (str >= 0) {
			json.put("code", UserEnum.REG_SUCCESS.code);
			json.put("msg", UserEnum.REG_SUCCESS.msg);
		} else {
			json.put("code", UserEnum.REG_ERROR.code);
			json.put("msg",  UserEnum.REG_ERROR.msg);
		}
		json.put("id", str);
		return json.toString();
	}

	@RequestMapping("/user/test.do")
	@ResponseBody
	public String testLogin(HttpServletRequest request) {
		int udata = -1;
		User user=null;
		String referer=request.getHeader("referer");
		JSONObject json = new JSONObject();
		try {
			String ujson = RedisUtlis.get(Tools.getCookie(request,"login"));
			JSONObject reJson=new JSONObject(ujson);
			udata = reJson.getInt("uid");
			user=userService.getUser(udata);
		} catch (Exception e) {
			// TODO: handle exception
		}
		UGroup group=permissionService.getGroup("管理员");
		request.getSession().setAttribute("adminPower", group.getPermission());
		int upower=UserPower.getPower(referer);

		if (udata == -1||udata==-999) {
			json.put("code", UserEnum.LOGIN_NOT_LOGIN.code);
			json.put("msg",  UserEnum.LOGIN_NOT_LOGIN.msg);
		} else {
			json.put("code", UserEnum.LOGIN_SUCCESS.code);
			json.put("msg", UserEnum.LOGIN_SUCCESS.msg);
		}
		if(user!=null) {
			if(user.getPower()<upower) {
				json.put("code", UserEnum.LOGIN_NOT_POWER.code);
				json.put("msg", UserEnum.LOGIN_NOT_POWER.msg);
			}
		}
		return json.toString();
	}

	@RequestMapping("/user/logout.do")
	@ResponseBody
	public String logout(HttpServletRequest request) {
		RedisUtlis.remove(Tools.getCookie(request,"login"));
		return "{}";
	}

}
