package com.yutou.controller.Web;

import java.util.ArrayList;
import java.util.List;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import com.yutou.utlis.Tools;
import org.json.JSONObject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.alibaba.fastjson.JSON;
import com.yutou.enums.ModEnum;
import com.yutou.mybatis.TMod;
import com.yutou.mybatis.User;
import com.yutou.services.AppConfig;
import com.yutou.services.ModService;
import com.yutou.services.UserService;
import com.yutou.utlis.RedisUtlis;

@RequestMapping("mod")
@Controller
public class WebModController {
	@Resource
	ModService modService;
	@Resource
	AppConfig appService;
	@Resource
	UserService user;
	
	
	
	@RequestMapping("/user.do")
	@ResponseBody
	public String getUser(HttpServletRequest request) {
		JSONObject json = new JSONObject();
		List<TMod> list=new ArrayList<>();
		try {
			JSONObject user=new JSONObject(RedisUtlis.get(Tools.getCookie(request,"login")));
			list = modService.getUserOfId(user.getInt("id"));
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		json.put("code", 0);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		return json.toString();
	}
	
	@RequestMapping("/all.do")
	@ResponseBody
	public String getAllMod(HttpServletRequest request, String min_str, String max_str) {
		int min, max;
		JSONObject json = new JSONObject();
		try {
			min = Integer.valueOf(min_str);
		} catch (Exception e) {
			// TODO: handle exception
			min = -1;
		}
		try {
			max = Integer.valueOf(max_str);
		} catch (Exception e) {
			// TODO: handle exception
			max = -1;
		}
		int uPower = 0;
		try {
			int _uid = Integer.valueOf((String) request.getAttribute("uid"));
			User u = user.getUser(_uid);
			uPower = u.getPower();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		
		List<TMod> list = modService.getMods(min, max, uPower);
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		if (list.size() == 0 || (list.size() < (max - min))) {
			json.put("pager", false);
		} else {
			json.put("pager", true);
		}
		return json.toString();
	}
	
	@RequestMapping("/search.do")
	@ResponseBody
	public String search(HttpServletRequest request, String key) {
		List<TMod> list = modService.getMod(key, (int)request.getAttribute("upower"));
		JSONObject json = new JSONObject();
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		return json.toString();
	}
}
