package com.yutou.controller.Web;

import java.util.List;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.yutou.utlis.Log;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.yutou.mybatis.UGroup;
import com.yutou.mybatis.User;
import com.yutou.services.PermissionService;
import com.yutou.services.UserService;
import com.yutou.utlis.EmailTools;
import com.yutou.utlis.Tools;

@RequestMapping("permission")
@Controller
public class WebPermissionController {
	@Resource
	PermissionService permissionService;
	@Resource
	UserService userService;
	
	@RequestMapping("/getGroup.do")
	@ResponseBody
	public String getGroup(HttpServletRequest request,HttpServletResponse response) {
		response.setContentType("text/html;charset=UTF-8");
		List<UGroup> list=permissionService.getGroup();
		JSONObject json=new JSONObject();
		JSONArray array=new JSONArray();
		User user=userService.getUser(Tools.getUserId(request));
		Log.i(user);
		for (UGroup group : list) {
			JSONObject tmp=new JSONObject();
			tmp.put("permission", group.getTitle());
			tmp.put("state", permissionService.getGroup(user.getPower(),group)!=null? "已获取":"未获取");
			tmp.put("stateValue", group.getInfo().contains("无法获取")?0:1);
			tmp.put("info", group.getInfo());
			tmp.put("id", group.getPermission());
			if(group.getInfo().contains("无法获取")) {
				tmp.put("id", 0);
			}
			array.put(tmp);
		}
		json.put("code", 0);
		json.put("msg", "成功");
		json.put("data", array);
		return json.toString();
	}
	@RequestMapping("/apply.do")
	@ResponseBody
	public String apply(int permission,HttpServletRequest request,HttpServletResponse response) {
		response.setContentType("text/html;charset=UTF-8");
		JSONObject json=new JSONObject();
		UGroup group=permissionService.getGroup(permission, null);
		int uid=Tools.getUserId(request);
		if(group.getPermission()>500||permission==0) {
			json.put("code", -1);
			json.put("msg", "无法申请该权限");
		}else {
			User user=userService.getUser(uid);
			EmailTools.send("583819556@qq.com","[舰R魔改宝盒]用户申请权限提醒邮件","用户 "+user.getName()+"(UID:"+user.getId()+") 申请 ["+group.getTitle()+"](id:"+group.getId()+")权限，请前往后台审核");
			json.put("code", 0);
			json.put("msg", "已为您申请该权限，请等待审核");
		}
		return json.toString();
	}
}
