package com.yutou.controller.Web;

import java.io.File;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import com.yutou.enums.UserEnum;
import com.yutou.mybatis.User;
import com.yutou.services.ModService;
import com.yutou.services.UserService;
import com.yutou.utlis.Log;
import com.yutou.utlis.RedisUtlis;
import com.yutou.utlis.ServiceStaticValue;
import com.yutou.utlis.Tools;

/**
 * 上传魔改页面的接口
 * 
 * @author yutou
 *
 */
@Controller
public class WebUploadModController {
	@Resource
	UserService userService;
	@Resource
	ModService modService;

	@RequestMapping("/mod/upload/upload.do")
	@ResponseBody
	public String upload(HttpServletRequest request) {
		JSONObject json = new JSONObject();
		JSONObject data=null;
		String _json=request.getParameter("json");
		String _files=request.getParameter("files");
		if(Tools.StringIsEmpty(_json)) {
			json.put("code", "-1");
			json.put("msg", "参数异常！请截图本页面后反馈至管理员");
			return json.toString();
		}
		data=new JSONObject(_json);
		User user=null;
		try {
			JSONObject ujson=new JSONObject(RedisUtlis.get(Tools.getCookie(request,"login")));
			int uid =  ujson.getInt("uid");
			user=userService.getUser(uid);
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
			json.put("code", UserEnum.LOGIN_NOT_LOGIN.code);
			json.put("msg", UserEnum.LOGIN_NOT_LOGIN.msg);
			return json.toString();
		}
		JSONObject iconJson=(JSONObject) Tools.getSessionKey(request, "icon");
		JSONObject imageJson=(JSONObject) Tools.getSessionKey(request, "image");
		JSONArray filesJson;
		if(_files!=null) {
			try {
				filesJson=new JSONArray(_files);
			} catch (Exception e) {
				filesJson=new JSONArray();
				Log.printf_Error(e, WebUploadModController.this);
			}
		}else {
			filesJson=new JSONArray();
		}
		if(iconJson!=null)
			data.put("icon", iconJson.getString("url"));
		if(imageJson!=null)
			data.put("image", imageJson.getString("url"));
		if(filesJson!=null)
			data.put("files", filesJson);
		json.put("code", "1");
		json.put("msg", "提交成功！");
		
		data.put("byid", user.getId());
		
		data=new JSONObject(data.toString().replaceAll(ServiceStaticValue.SERVICE_URL, ""));
		Log.i("上传总接口", data.toString());
		
		if(modService.upload(data)==1) {
			new File(Tools.getRootModsPath(request)+data.getString("path")+"/lock").delete();
		}
		return json.toString();
	}
	@RequestMapping("/mod/upload/icon.do")
	@ResponseBody
	public String upload_icon(@RequestParam(value = "icon", required = false) MultipartFile file,HttpServletRequest request) {
		JSONObject json=new JSONObject();
		try {
			String url=Tools.createFile(request, "mods"+"/"+request.getParameter("path")+"/", file,"icon.png");
			json.put("id", 1);
			json.put("url", ServiceStaticValue.SERVICE_URL+url);
			json.put("path", request.getParameter("path"));
			Log.i("上传", Tools.getRootModsPath(request)+request.getParameter("path")+File.separator+"lock");
			if(!new File(Tools.getRootModsPath(request)+request.getParameter("path")+File.separator).exists()){
				new File(Tools.getRootModsPath(request)+request.getParameter("path")+File.separator).mkdirs();
			}
			new File(Tools.getRootModsPath(request)+request.getParameter("path")+File.separator+"lock").createNewFile();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Log.i("上传图标", json.toString());
		Tools.saveSession(request, "icon", json);
		return json.toString();
	}
	@RequestMapping("/mod/upload/image.do")
	@ResponseBody
	public String upload_image(@RequestParam(value = "image", required = false) MultipartFile file,HttpServletRequest request) {
		JSONObject json=new JSONObject();
		try {
			String url=ServiceStaticValue.SERVICE_URL+Tools.createFile(request, "mods/"+request.getParameter("path")+"/", file,"image.png");
			json.put("id", 2);
			json.put("url", url);
			json.put("path", request.getParameter("path"));
			new File( Tools.getRootModsPath(request)+request.getParameter("path")+"/lock").createNewFile();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Tools.saveSession(request, "image", json);
		return json.toString();
	}
	@RequestMapping("/mod/upload/files.do")
	@ResponseBody
	public String upload_file(@RequestParam(value = "file", required = false) MultipartFile file,HttpServletRequest request) {
		JSONObject json=new JSONObject();
		try {
			String url=Tools.createFile(request, "mods/"+request.getParameter("path")+"/", file,null);
			json.put("id", 3);
			json.put("url", url);
			json.put("name", file.getOriginalFilename());
			json.put("path", request.getParameter("path"));
			new File(Tools.getRootModsPath(request)+request.getParameter("path")+"/lock").createNewFile();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Log.i("上传文件"+json.toString());
		return json.toString();
	}
}
