package com.yutou.controller.admin;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.yutou.enums.UserEnum;
import com.yutou.services.MagicBoxService;
import org.json.JSONObject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.yutou.enums.POWER;
import com.yutou.mybatis.User;
import com.yutou.services.PermissionService;
import com.yutou.services.UserService;
import com.yutou.utlis.RedisUtlis;
import com.yutou.utlis.Tools;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;

@Controller
@RequestMapping("/admin/magicbox")
public class AdminMagicBoxController {
	@Resource
	UserService userService;
	@Resource
	PermissionService powerService;
	@Resource
	MagicBoxService magicBoxService;

	@RequestMapping("/data.do")
	@ResponseBody
	public String defined(HttpServletResponse response, HttpServletRequest request, String data, String set) {
		String tmp = "";
		if (set == null) {
			tmp = RedisUtlis.get(data);
		} else if (!isAdmin(request)) {
			return "404 not fount";
		} else {
			tmp = RedisUtlis.set(data, set,-1) + "";
		}
		return tmp;
	}

	@RequestMapping("/activity.do")
	@ResponseBody
	public  String setActivityTime(HttpServletRequest request,String title,String url,String start,String end){
		JSONObject json=new JSONObject();
		if(!isAdmin(request)){
			json.put("data", UserEnum.LOGIN_NOT_LOGIN.code);
			json.put("msg",UserEnum.LOGIN_NOT_LOGIN.msg);
			return json.toString();
		}
		try {
			SimpleDateFormat startDate=new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			SimpleDateFormat entDate=new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			startDate.setTimeZone(TimeZone.getTimeZone("GMT+8:00"));
			entDate.setTimeZone(TimeZone.getTimeZone("GMT+8:00"));
			int ret=magicBoxService.setActivityTime(title,url,startDate.parse(start),entDate.parse(end));
			if(ret==1){
				json.put("data",0);
				json.put("msg","提交成功");
			}else{
				json.put("data",-1);
				json.put("msg","提交失败");
			}
		} catch (ParseException e) {
			e.printStackTrace();
			json.put("data",-1);
			json.put("msg","时间异常");
		}

		return json.toString();

	}
	@RequestMapping("/banner.do")
	@ResponseBody
	public String setBanner(HttpServletRequest request,int id,String url,String click,String state){
		JSONObject json=new JSONObject();
		if(!isAdmin(request)){
			json.put("data", UserEnum.LOGIN_NOT_LOGIN.code);
			json.put("msg",UserEnum.LOGIN_NOT_LOGIN.msg);
			return json.toString();
		}
		int _state=-999;
		try {
			_state=Integer.parseInt(state);
		}catch (Exception e){
			e.printStackTrace();
		}
		int ret=magicBoxService.setBanner(id,url,click,_state);
		if(ret==1){
			json.put("data",0);
			json.put("msg","提交成功");
		}else{
			json.put("data",-1);
			json.put("msg","提交失败");
		}
		return json.toString();
	}

	public boolean isAdmin(HttpServletRequest request) {
		try {
			int uid = Tools.getUserId(request);
			User user = userService.getUser(uid);
			if (user.getPower() < powerService.getGroup(POWER.ADMIN, null).getPermission()) {
				return false;
			}
			return true;
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		return false;
	}
}
