package com.yutou.controller.android;

import java.util.Date;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import org.json.JSONObject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.alibaba.fastjson.JSON;
import com.yutou.enums.UserEnum;
import com.yutou.mybatis.MAdConfig;
import com.yutou.mybatis.MAdLog;
import com.yutou.mybatis.UUserdata;
import com.yutou.services.AdService;
import com.yutou.services.UserService;
import com.yutou.utlis.Tools;

@RequestMapping("/android/ad/")
@Controller
public class AdController {
	@Resource
	UserService user;
	@Resource
	AdService adService;

	@RequestMapping("ad.do")
	@ResponseBody
	public String getAd(HttpServletRequest request) {
		JSONObject json = new JSONObject();
		json.put("code", UserEnum.LOGIN_SUCCESS.code);
		json.put("msg", UserEnum.LOGIN_SUCCESS.msg);
		int type = Integer.valueOf(request.getParameter("type"));
		int uid =Tools.getUidOfToken(request);
		if(adService.getUserAd(4, uid)>=5) {
			json.put("data", JSON.toJSON(new MAdConfig()));
			return json.toString();
		}
		MAdConfig ad = adService.getAd(type);
		if (ad.getAdshow() == 1) {
			json.put("data", JSON.toJSON(ad));
		} else {
			json.put("data", JSON.toJSON(new MAdConfig()));
		}
		return json.toString();
	}

	@RequestMapping("user.do")
	@ResponseBody
	public String userAction(HttpServletRequest request) {
		JSONObject json = new JSONObject();
		int uid = Tools.getUidOfToken(request);
		if (uid > 0) {
			int adType = Integer.valueOf(request.getParameter("adtype"));// 1开屏、2插屏、3banner、4原生
			int uType = Integer.valueOf(request.getParameter("utype"));// 0请求、1展示、2点击
			String imei = request.getParameter("imei");
			String ip =Tools.getRemoteAddress(request);
			MAdLog log = new MAdLog();
			log.setAdtype(adType);
			log.setUtype(uType);
			log.setUid(uid);
			log.setImei(imei);
			log.setIp(ip);
			log.setCreatetime(new Date());
			adService.addAdLog(log);
			json.put("code", UserEnum.LOGIN_SUCCESS.code);
			json.put("msg", UserEnum.LOGIN_SUCCESS.msg);
			JSONObject tmp=new JSONObject();
			UUserdata data = user.getUUserData(uid);
			if (uType == 2) {
				switch (adType) {
				case 1:
					data.setCredit(data.getCredit()+2);
					tmp.put("msg", "获得 "+2+"积分");
					break;
				case 3:
					data.setCredit(data.getCredit()+1);
					tmp.put("msg", "新增 "+1+"积分");
					break;
				case 4:
					data.setCredit(data.getCredit()+2);
					tmp.put("msg", "新增 "+2+"积分");
					break;
				default:
					break;
				}
				user.updateUserData(data);
				tmp.put("code", 100);
			}else {
				tmp.put("code", 101);
				
			}
			tmp.put("user", user.getUserData(uid));
			json.put("data", tmp);
		} else {
			json.put("code", UserEnum.LOGIN_NOT_LOGIN.code);
			json.put("msg", UserEnum.LOGIN_NOT_LOGIN.msg);
			json.put("data", "{}");
		}
		return json.toString();
	}

}
