package com.yutou.controller.android;

import java.util.Date;
import java.util.List;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.JSONObject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.alibaba.fastjson.JSON;
import com.yutou.enums.ModEnum;
import com.yutou.mybatis.MAppHome;
import com.yutou.mybatis.MAppHomeConfig;
import com.yutou.mybatis.MAppMg;
import com.yutou.mybatis.MAppTools;
import com.yutou.mybatis.SConfig;
import com.yutou.mybatis.TModfilePath;
import com.yutou.services.AppConfig;
import com.yutou.services.ModService;
import com.yutou.utlis.Tools;

@Controller
@RequestMapping("android/config/")
public class AppController {
	@Resource
	AppConfig appConfig;
	@Resource
	ModService modService;
	
	
	@RequestMapping("get.do")
	@ResponseBody
	public String getAppConfig(HttpServletRequest request) {
		SConfig config=appConfig.getConfig(1);
		JSONObject json=new JSONObject();
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", config);
		return json.toString();
	}
	@RequestMapping("home.do")
	@ResponseBody
	public String getHome(String all,HttpServletRequest request) {
		boolean flag=false;
		if(!Tools.StringIsEmpty(all)) {
			if(all.equals("true")) {
				flag=true;
			}
		}
		List<MAppHome> list=appConfig.getHomeList(flag);
		JSONObject json=new JSONObject();
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		return json.toString();
	}
	@RequestMapping("utils.do")
	@ResponseBody
	public String getUtils(HttpServletRequest request,int min,int max) {
		String uid=Tools.getUidOfToken(request)+"";
		String version=request.getParameter("clientVersion");
		List<MAppTools> list=appConfig.getTools(uid,version);
		JSONObject json=new JSONObject();
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		return json.toString();
	}
	@RequestMapping("mg.do")
	@ResponseBody
	public String getMg(String all,HttpServletRequest request,HttpServletResponse response) {
		Tools.resetCode(response);
		boolean flag=false;
		if(!Tools.StringIsEmpty(all)) {
			if(all.equals("true")) {
				flag=true;
			}
		}
		List<MAppMg> list=appConfig.getMgList(flag);
		JSONObject json=new JSONObject();
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		return json.toString();
	}
	@RequestMapping("update.do")
	@ResponseBody
	public String getUpdate(HttpServletRequest request) {
		SConfig config=appConfig.getConfig(1);
		JSONObject json=new JSONObject();
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(config));
		return json.toString();
	}
	@RequestMapping("gameActivity.do")
	@ResponseBody
	public String getGameActivity(HttpServletRequest request) {
		MAppHomeConfig activity;
		List<MAppHomeConfig> list=appConfig.getAppHomeConfig();
		if(list.size()>0) {
			activity=list.get(0);
		}else {
			activity=new MAppHomeConfig();
			activity.setName("长草中...");
			activity.setStartdate(new Date());
			activity.setEnddate(activity.getStartdate());
			activity.setState(-1);
			activity.setUrl("#");
		}
		JSONObject json=new JSONObject();
		JSONObject data=new JSONObject(JSON.toJSONString(activity));
		data.put("startdate", activity.getStartdate().getTime());
		data.put("enddate", activity.getEnddate().getTime());
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data",data );
		
		return json.toString();
	}
	
	@RequestMapping("/installPath.do")
	@ResponseBody
	public String getInstallPath(HttpServletRequest request) {
		List<TModfilePath> paths=modService.getInstallPaths();
		JSONObject json=new JSONObject();
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(paths));
		return json.toString();
	}
}
