package com.yutou.controller.android;

import java.util.List;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import org.json.JSONObject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.yutou.enums.UserEnum;
import com.yutou.mybatis.UUserGameData;
import com.yutou.mybatis.UUserdata;
import com.yutou.services.UserService;
import com.yutou.utlis.QiniuTools;
import com.yutou.utlis.RedisUtlis;
import com.yutou.utlis.Tools;

@RequestMapping("android/data")
@Controller
public class DataController {
	@Resource
	UserService user;

	@RequestMapping("/upGameData.do")
	@ResponseBody
	public String upGameData(HttpServletRequest request) {
		JSONObject json = new JSONObject();
		JSONObject tmp = new JSONObject();
		String gameDataSize=request.getParameter("gameDataSize");
		long gameSize=-1;
		try {
			gameSize=Long.parseLong(gameDataSize);
		} catch (Exception e) {
			// TODO: handle exception
		}
		int uid = Tools.getUidOfToken(request);
		if (uid == 0) {
			json.put("code", UserEnum.LOGIN_NOT_LOGIN.code);
			json.put("msg", UserEnum.LOGIN_NOT_LOGIN.msg);
			tmp.put("token", "");
		} else {
			UUserdata udata = user.getUUserData(uid);
			if (udata.getCredit() - (gameSize/1024/1024) < 0) {
				json.put("code", UserEnum.LOGIN_NOT_LOGIN.code);
				json.put("msg", "用户积分不足");
				tmp.put("token", "");
			} else {
				String token = QiniuTools.init().getQiniuToken();
				tmp.put("token", token);
				RedisUtlis.set(token, "gamedata",60*60*1000);
				json.put("credit", (gameSize/1024/1024));
				json.put("code", UserEnum.LOGIN_SUCCESS.code);
				json.put("msg", UserEnum.LOGIN_SUCCESS.msg);
			}
			List<UUserGameData> gameData=user.getGameData(uid);
			if(gameData.size()==0) {
				tmp.put("uptime", "0");
				tmp.put("upindex", 0);
			}else {
				tmp.put("uptime", gameData.get(0).getUpdatetime().getTime());
				tmp.put("upindex", gameData.get(0).getUpindex());
			}
		}
		json.put("data", tmp);
		return json.toString();
	}

	@RequestMapping("/downGameData.do")
	@ResponseBody
	public String getGameData(HttpServletRequest request) {
		JSONObject json = new JSONObject();
		JSONObject tmp = new JSONObject();
		int uid = Tools.getUidOfToken(request);
		if (uid > 0) {
			List<UUserGameData> gameData = user.getGameData(uid);
			if (gameData.size() > 0) {
				tmp.put("url", "http://hzcdn.jianrmod.cn/" + gameData.get(0).getFile());
				json.put("code", UserEnum.LOGIN_SUCCESS.code);
				json.put("msg", UserEnum.LOGIN_SUCCESS.msg);
			} else {
				tmp.put("url", "#");
				json.put("code", UserEnum.LOGIN_NOT_LOGIN.code);
				json.put("msg", "没有上传过文件");
			}
		} else {
			json.put("code", UserEnum.LOGIN_NOT_LOGIN.code);
			json.put("msg", UserEnum.LOGIN_NOT_LOGIN.msg);
			tmp.put("url", "#");
		}
		json.put("data", tmp);
		return json.toString();
	}
}
