package com.yutou.controller.android;

import java.util.ArrayList;
import java.util.List;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.alibaba.fastjson.JSON;
import com.yutou.enums.ModEnum;
import com.yutou.enums.UserEnum;
import com.yutou.enums.UserPower;
import com.yutou.mybatis.MGamePackname;
import com.yutou.mybatis.TMod;
import com.yutou.mybatis.TModcomment;
import com.yutou.mybatis.TModfile;
import com.yutou.mybatis.TModtag;
import com.yutou.mybatis.User;
import com.yutou.services.AppConfig;
import com.yutou.services.ModService;
import com.yutou.services.UserService;
import com.yutou.utlis.Log;
import com.yutou.utlis.RedisUtlis;
import com.yutou.utlis.Tools;

@RequestMapping("android/mod")
@Controller
public class ModController {
	@Resource
	ModService modService;
	@Resource
	AppConfig appService;
	@Resource
	UserService user;
	private static final String LOGINSTATE = "loginState";

	@ModelAttribute
	public void test(HttpServletRequest request, String token, String uid) {
		if ( Tools.getUidOfToken(request)>0) {
			request.setAttribute(LOGINSTATE, true);
		} else {
			request.setAttribute(LOGINSTATE, false);
		}
		User u=user.getUser(Tools.getUidOfToken(request));
		
		if(u!=null) {
			request.setAttribute("uid", u.getId());
		request.setAttribute("upower", u.getPower());
		}
		else {
			request.setAttribute("uid", 0);
			request.setAttribute("upower", 0);
		}
		request.setAttribute("token", token);
		u=null;
	}

	@RequestMapping("/all.do")
	@ResponseBody
	public String getAllMod(HttpServletRequest request, String min_str, String max_str) {
		int min, max;
		JSONObject json = new JSONObject();
		try {
			min = Integer.parseInt(min_str);
		} catch (Exception e) {
			// TODO: handle exception
			min = -1;
		}
		try {
			max = Integer.parseInt(max_str);
		} catch (Exception e) {
			// TODO: handle exception
			max = -1;
		}
		max=99999;
		int uPower = 0;
		if ((boolean) request.getAttribute(LOGINSTATE)) {
			try {
				int _uid = Tools.getUidOfToken(request);
				User u = user.getUser(_uid);
				uPower = u.getPower();
			} catch (Exception e) {
				// TODO: handle exception
				e.printStackTrace();
			}
		}
		List<TMod> list = modService.getMods(min, max, uPower);
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		if (list.size() == 0 || (list.size() < (max - min))) {
			json.put("pager", false);
		} else {
			json.put("pager", true);
		}
		return json.toString();
	}

	@RequestMapping("/search.do")
	@ResponseBody
	public String search(HttpServletRequest request, String key) {
		List<TMod> list = modService.getMod(key, (int)request.getAttribute("upower"));
		JSONObject json = new JSONObject();
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		return json.toString();
	}

	@RequestMapping("/getMod.do")
	@ResponseBody
	public String getMod(HttpServletRequest request, String id) {
		JSONObject json = new JSONObject();
		int _id = -1;
		try {
			_id = Integer.valueOf(id);
		} catch (Exception e) {
			// TODO: handle exception
			json.put("code", ModEnum.ERROR.code);
			json.put("msg", ModEnum.ERROR.msg);
			json.put("data", "");
			return json.toString();
		}
		TMod mod = modService.getMod(_id, (int)request.getAttribute("upower"));
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", mod);
		return json.toString();
	}

	@RequestMapping("/getMods.do")
	@ResponseBody
	public String getMods(HttpServletRequest request, String ids) {
		List<TMod> mods = new ArrayList<>();
		try {
			JSONArray _ids = new JSONArray(ids);
			for (int i = 0; i < _ids.length(); i++) {
				mods.add(modService.getMod(_ids.getInt(i), (int)request.getAttribute("upower")));
			}
		} catch (Exception e) {
			// TODO: handle exception
		}
		JSONObject json = new JSONObject();
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(mods));
		return json.toString();
	}

	@RequestMapping("/getComment.do")
	@ResponseBody
	public String getComment(HttpServletRequest request, String id) {
		JSONObject json = new JSONObject();
		int _id = -1;
		try {
			_id = Integer.valueOf(id);
		} catch (Exception e) {
			// TODO: handle exception
			json.put("code", ModEnum.ERROR.code);
			json.put("msg", ModEnum.ERROR.msg);
			json.put("data", "");
			return json.toString();
		}
		List<TModcomment> list = modService.getModComment(_id);
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		return json.toString();
	}

	@RequestMapping("/getType.do")
	@ResponseBody
	public String getType(HttpServletRequest request, String mType, String jType) {
		boolean isModType = mType == null ? false : true;
		Log.i("/getType.do", "mType:" + mType + " jType:" + jType + " isType:" + isModType);
		JSONObject json = new JSONObject();
		List<?> list = new ArrayList<>();
		int tmp = 0;
		if (isModType) {
			try {
				tmp = Integer.valueOf(mType);
			} catch (Exception e) {
				// TODO: handle exception
			}
			list = modService.getTypeOfMod(tmp);
		} else {
			try {
				tmp = Integer.valueOf(jType);
			} catch (Exception e) {
				// TODO: handle exception
			}
			list = modService.getTypeOfJian(tmp);
		}
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		return json.toString();
	}

	@RequestMapping("/user.do")
	@ResponseBody
	public String getUser(HttpServletRequest request, String uid) {
		int _uid = -1;
		JSONObject json = new JSONObject();
		try {
			_uid = Integer.valueOf(uid);
		} catch (Exception e) {
			// TODO: handle exception
			json.put("code", ModEnum.ERROR.code);
			json.put("msg", ModEnum.ERROR.msg);
			json.put("data", "");
			return json.toString();
		}
		List<TMod> list = modService.getUserOfId(_uid);
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		return json.toString();
	}

	@RequestMapping("/remod.do")
	@ResponseBody
	public String getReMod(HttpServletRequest request, String mid, String remid) {
		int _mid = 0;
		int _remid = 0;
		JSONObject json = new JSONObject();
		try {
			_mid = Integer.valueOf(mid);
		} catch (Exception e) {
			// TODO: handle exception
		}
		try {
			_remid = Integer.valueOf(remid);
		} catch (Exception e) {
			// TODO: handle exception
		}
		List<TMod> list = modService.getReMod(_mid, _remid);
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		return json.toString();
	}

	@RequestMapping("/tags.do")
	@ResponseBody
	public String getModTag(HttpServletRequest request, String mid) {
		int _mid = 0;
		try {
			_mid = Integer.valueOf(mid);
		} catch (Exception e) {
			// TODO: handle exception
		}
		JSONObject json = new JSONObject();
		List<TModtag> list = modService.getModTag(_mid);
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		return json.toString();
	}

	@RequestMapping(value = "/download.do", produces = "text/html;charset=UTF-8")
	@ResponseBody
	public String getDownload(HttpServletRequest request, String mid, String uid) {
		int _mid = 0;
		int _uid = 0;
		try {
			_mid = Integer.valueOf(mid);
		} catch (Exception e) {
			// TODO: handle exception
		}
		try {
			_uid = Integer.valueOf(uid);
		} catch (Exception e) {
			// TODO: handle exception
		}

		List<TModfile> list = modService.getModFile(_mid, _uid);
		JSONObject json = new JSONObject();
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		return json.toString();
	}

	@RequestMapping("/packnames.do")
	@ResponseBody
	public String getPackNames(HttpServletRequest request) {
		List<MGamePackname> list = appService.getPackNames(false);
		JSONObject json = new JSONObject();
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(list));
		return json.toString();
	}

	@RequestMapping("/getCollect.do")
	@ResponseBody
	public String getUserCollect(HttpServletRequest request) {
		JSONObject json = new JSONObject();
		String min = request.getParameter("min");
		String max = request.getParameter("max");
		if (!(boolean) request.getAttribute(LOGINSTATE)) {
			json.put("state", request.getAttribute(LOGINSTATE));
			json.put("msg", "登录信息失效");
			json.put("code", 101);
			return json.toString();
		}
		int _min = Integer.valueOf(min);
		int _max = Integer.valueOf(max);
		int _id = Integer.valueOf(Tools.getUidOfToken(request));
		List<TMod> mods = user.userCollectMod(_min, _max, _id);
		json.put("msg", "获取成功");
		json.put("data", JSON.toJSON(mods));
		json.put("next", (_max < user.userCollectMod(0, -1, _id).size()) ? true : false);
		json.put("code", UserEnum.LOGIN_SUCCESS.code);
		return json.toString();
	}

	@RequestMapping("/removeCollect.do")
	@ResponseBody
	public String removeUserCollect(HttpServletRequest request) {
		JSONObject json = new JSONObject();
		String mid = request.getParameter("mid");
		if (!(boolean) request.getAttribute(LOGINSTATE)) {
			json.put("state", request.getAttribute(LOGINSTATE));
			json.put("msg", "登录信息失效");
			json.put("code", 101);
			return json.toString();
		}
		if (user.removeCollectMod(Integer.valueOf(mid)) == 1) {
			json.put("data", true);
			json.put("msg", "移除收藏成功");
		} else {
			json.put("data", false);
			json.put("msg", "移除收藏失败");
		}
		json.put("code", UserEnum.LOGIN_SUCCESS.code);
		return json.toString();
	}

	@RequestMapping("/collection.do")
	@ResponseBody
	public String setCollection(HttpServletRequest request, String mid) {
		if (!(boolean) request.getAttribute(LOGINSTATE)) {
			JSONObject error = new JSONObject();
			error.put("msg", "失败");
			error.put("code", "0101");
			return error.toString();
		}
		JSONObject json = new JSONObject();
		json.put("code", ModEnum.SUCCESS.code);
		json.put("msg", ModEnum.SUCCESS.msg);
		json.put("data", JSON.toJSON(modService.setConllection(request.getAttribute("uid").toString(), mid)));
		return json.toString();
	}

	@RequestMapping("/move.do")
	@ResponseBody
	public String AdminMod(HttpServletRequest request) {
		JSONObject json = new JSONObject();
		String token = request.getParameter("token");
		String mid = request.getParameter("mid");
		String type = request.getParameter("type");
		if (!(boolean) request.getAttribute(LOGINSTATE)) {
			json.put("state", request.getAttribute(LOGINSTATE));
			json.put("msg", "信息失效");
			json.put("code", 101);
			return json.toString();
		}
		User u = user.getUser(Integer.valueOf(RedisUtlis.get(token)));
		if (u.getPower() < UserPower.Power.U_Auditor.code) {
			json.put("state", request.getAttribute(LOGINSTATE));
			json.put("msg", UserEnum.LOGIN_NOT_POWER.msg);
			json.put("code", UserEnum.LOGIN_NOT_POWER.code);
			return json.toString();
		}
		int i = 0;
		switch (type) {
		case "0":
			i = modService.setModPower(Integer.valueOf(mid), 0);
			break;
		case "1":
			i = modService.setModPower(Integer.valueOf(mid), 1);
			break;
		case "move":
			String newjType = request.getParameter("jType");
			String newmType = request.getParameter("mType");
			if (!Tools.StringIsEmpty(newjType, newmType)) {
				i = modService.moveMod(Integer.valueOf(mid), newjType, newmType);
			}
			break;
		default:
			break;
		}
		json.put("code", 100);
		json.put("msg", i == 1 ? "修改成功" : "修改失败");
		return json.toString();
	}

	@RequestMapping(value = "/typeInfo.do", produces = "text/html;charset=UTF-8")
	@ResponseBody
	public String getModType(HttpServletRequest request) {
		JSONObject json = new JSONObject();
		json.put("msg", "ok");
		json.put("code", 100);
		json.put("data", modService.getTypeInfo());
		return json.toString();
	}
}
