package com.yutou.controller.android;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.alibaba.fastjson.JSON;
import com.yutou.enums.UserEnum;
import com.yutou.mybatis.MAppLicense;
import com.yutou.mybatis.MAppLicenseExample;
import com.yutou.mybatis.UUserdata;
import com.yutou.mybatis.dao.MAppLicenseMapper;
import com.yutou.services.PlugsService;
import com.yutou.services.SystemService;
import com.yutou.services.UserService;
import com.yutou.utlis.EmailTools;
import com.yutou.utlis.RedisUtlis;
import com.yutou.utlis.Tools;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

@RequestMapping("/android/system")
@Controller
public class SystemController {
	@Resource 
	SystemService systemService;
	@Resource
	UserService user;
	@Resource
	MAppLicenseMapper mapper;
	@Resource
	PlugsService pluginService;
	private static final String LOGINSTATE="loginState";
	@ModelAttribute
	public void test(HttpServletRequest request, String token, String uid) {
		if (RedisUtlis.exists(token, uid)) {
			request.setAttribute(LOGINSTATE, true);
		} else {
			request.setAttribute(LOGINSTATE, false);
		}
		request.setAttribute("uid", uid);
		request.setAttribute("token", token);
	}
	@RequestMapping("/addFeedBack.do")
	@ResponseBody
	public String addFeedBack(HttpServletRequest request) {
		JSONObject json=new JSONObject();
		int uid_ = Tools.getUidOfToken(request);
		if(uid_==-1){
			uid_=new JSONObject(RedisUtlis.get(Tools.getCookie(request,"login"))).getInt("uid");
		}
		if(uid_==0){
			uid_=Tools.getUserId(request);
		}
		int androidUId=-1;
		try {
			androidUId=Integer.parseInt(request.getParameter("uid"));
		}catch (Exception e){
			if(request.getParameter("sysinfo").equals("web")){
				androidUId=uid_;
			}
		}
		if (uid_ == 0||uid_!=androidUId) {
			json.put("code", UserEnum.LOGIN_NOT_LOGIN.code);
			json.put("msg", UserEnum.LOGIN_NOT_LOGIN.msg);
			return json.toString();
		}
		String uid=uid_+"";
		String context=request.getParameter("context");
		String sysinfo=request.getParameter("sysinfo");
		int _uid=0;
		try {
			_uid=Integer.parseInt(uid);
		} catch (Exception e) {
			// TODO: handle exception
		}
		if(Tools.StringIsEmpty(uid,context,sysinfo)) {
			json.put("code", 110);
			json.put("msg","参数不能为空");
			return json.toString();
		}
		json.put("code", 100);
		json.put("msg", systemService.addFeedBack(_uid, context, sysinfo)==1?"提交成功":"提交失败");
		UUserdata udata=user.getUUserData(Integer.parseInt(uid));
		String msg="来自uid:"+uid+"的问题反馈"+context+",系统信息:"+sysinfo+",对方邮箱:"+udata.getEmail();
		try {
			Tools.getHTTPUrlString("https://sc.ftqq.com/SCU64034T5adf5c5940dcecc016e0e9d0cf9b1e725da126ff47475.send?text="
					+ URLEncoder.encode("盒子问题反馈","UTF-8")
					+"&desp="+URLEncoder.encode(msg,"UTF-8"));
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		try {
			EmailTools.send("583819556@qq.com", "盒子问题反馈", "来自uid:"+uid+"的问题反馈\n"+context+"\n系统信息:"+sysinfo+"\n对方邮箱:"+udata.getEmail());
		} catch (Exception e) {
			// TODO: handle exception
		}
		return json.toString();
	}
	
	@RequestMapping("/license.do")
	@ResponseBody
	public String getLicense(HttpServletRequest request) {
		JSONObject json=new JSONObject();
		try {
			MAppLicenseExample example=new MAppLicenseExample();
			example.createCriteria().andNameEqualTo(request.getParameter("name"));
			MAppLicense license=mapper.selectByExample(example).get(0);
			json.put("data", JSON.toJSON(license));
		} catch (Exception e) {
			// TODO: handle exception
			json.put("data", JSON.toJSON(new MAppLicense()));
		}
		json.put("code", UserEnum.LOGIN_SUCCESS.code);
		json.put("msg", UserEnum.LOGIN_SUCCESS.msg);
		return json.toString();
	}
	@RequestMapping("/plugins.do")
	@ResponseBody
	public String getPlugins(HttpServletRequest request) {
		JSONObject json=new JSONObject();
		JSONArray plugins=new JSONArray();
		try {
			JSONArray array=new JSONArray(request.getParameter("array"));
			for (int i = 0; i < array.length(); i++) {
				JSONObject plugs=array.getJSONObject(i);
				if(pluginService.checkPlugs(plugs.getString("appid"),plugs.getString("md5"), plugs.getString("name"))!=null) {
					plugins.put(plugs.getString("name"));
				}
			}
			json.put("data", plugins);
		} catch (Exception e) {
			e.printStackTrace();
			// TODO: handle exception
			json.put("data", new JSONArray());
		}
		json.put("code", UserEnum.LOGIN_SUCCESS.code);
		json.put("msg", UserEnum.LOGIN_SUCCESS.msg);
		return json.toString();
	}
}
