package com.yutou.controller.android;

import java.util.Date;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.time.DateUtils;
import org.json.JSONObject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.alibaba.fastjson.JSON;
import com.yutou.enums.UserEnum;
import com.yutou.mybatis.UUserdata;
import com.yutou.mybatis.User;
import com.yutou.services.ModService;
import com.yutou.services.UserService;
import com.yutou.utlis.Log;
import com.yutou.utlis.MD5Signature;
import com.yutou.utlis.QiniuTools;
import com.yutou.utlis.RedisUtlis;
import com.yutou.utlis.ServiceStaticValue;
import com.yutou.utlis.Tools;

@RequestMapping("/android/user/")
@Controller
public class UserController {
	@Resource
	UserService user;
	@Resource
	ModService modService;

	@RequestMapping("login.do")
	@ResponseBody
	public String login(HttpServletRequest request, HttpServletResponse response) {
		Log.i(request.getAttribute("loginState") + "");
		String uname = request.getParameter("uname");
		String pass = request.getParameter("pass");
		int uid = user.login(uname, pass);
		JSONObject json = new JSONObject();
		if (Tools.StringIsEmpty(uname, pass)) {
			json.put("msg", "账号密码为空");
			json.put("code", "0203");
			return json.toString();
		}
		switch (uid) {
		case -2:
			json.put("msg", "失败/账户密码错误");
			json.put("code", "0101");
			break;
		case -1:
			json.put("msg", "你还没有注册呢");
			json.put("code", "0102");
			break;
		case -3:
			json.put("msg", UserEnum.LOGIN_BEAN.msg + "" + user.getUUserData(user.getUserId(uname)).getUnbeantime());
			json.put("code", UserEnum.LOGIN_BEAN.code);
			break;
		case -4:
			json.put("msg", UserEnum.LOGIN_blacklist.msg);
			json.put("code", UserEnum.LOGIN_blacklist.code);
			break;
		default:
			String token =Tools. getToken(request, uid);
			json.put("msg", "登录成功");
			json.put("code", UserEnum.LOGIN_SUCCESS.code);
			json.put("token", token);
			json.put("uid", uid);
			User u = user.getUser(uid);
			u.setPass("669969");

			json.put("data", JSON.toJSON(u));
			RedisUtlis.set(token, json.toString(), ServiceStaticValue.TOKEN_TIMEOUT);

			UUserdata udata = user.getUUserData(u.getId());
			if (!DateUtils.isSameDay(udata.getLogintime(), new Date())) {
				udata.setLogintime(new Date());
				udata.setCredit(udata.getCredit() + 1);
				user.updateUserData(udata);
			}
			break;
		}

		return json.toString();
	}

	@RequestMapping("reg.do")
	@ResponseBody
	public String reg(HttpServletRequest request) {
		String uname = request.getParameter("uname");
		String pass = request.getParameter("pass");
		String name = request.getParameter("name");
		String email = request.getParameter("email");
		JSONObject json = new JSONObject();
		if (Tools.StringIsEmpty(uname, pass)) {
			json.put("msg", "账号密码为空");
			json.put("code", "0203");
			return json.toString();
		}
		int str = user.reg(uname, name, pass);
		if (email != null && email.trim().length() > 0) {
			UUserdata data = user.getUUserData(str);
			data.setEmail(email);
			user.updateUserData(data);
		}
		if (str >= 0) {
			json.put("code", UserEnum.REG_SUCCESS.code);
			json.put("msg", UserEnum.REG_SUCCESS.msg);
			String token = Tools.getToken(request, str);
			json.put("token", token);
			json.put("uid", str);
			RedisUtlis.set(token, json.toString(), ServiceStaticValue.TOKEN_TIMEOUT);
		} else {
			json.put("code", UserEnum.REG_ERROR.code);
			json.put("msg", UserEnum.REG_ERROR.msg);
		}
		json.put("id", str);
		return json.toString();
	}

	@RequestMapping("reload.do")
	@ResponseBody
	public String reload(int uid, String token, HttpServletRequest request) {
		JSONObject json = new JSONObject();
		if ((boolean) request.getAttribute("loginState")) {
			String newtoken =Tools.getToken(request, uid);
			json.put("msg", "登录成功");
			json.put("code", UserEnum.LOGIN_SUCCESS.code);
			json.put("token", newtoken);
			RedisUtlis.set(token, uid + "", ServiceStaticValue.TOKEN_TIMEOUT);
		} else {
			json.put("msg", "登录失败");
			json.put("code", "0101");
			json.put("token", token);
		}
		return json.toString();
	}

	@RequestMapping("logout.do")
	@ResponseBody
	public String logout(HttpServletRequest request, String uid, String token) {
		JSONObject json = new JSONObject();
		Log.i(token);
		if (Tools.getUidOfToken(request)>0) {
			json.put("msg", "注销成功");
			json.put("code", UserEnum.LOGIN_SUCCESS.code);
			json.put("token", "");
			RedisUtlis.remove(token);
		} else {
			json.put("code", UserEnum.LOGIN_NOT_LOGIN.code);
			json.put("msg", UserEnum.LOGIN_NOT_LOGIN.msg);
		}
		return json.toString();
	}

	@RequestMapping("user.do")
	@ResponseBody
	public String getUserData(HttpServletRequest request, String token, int uid) {
		JSONObject json = new JSONObject();
		json.put("msg", "失败");
		json.put("code", "0101");
		if ((boolean) request.getAttribute("loginState")) {
			if (RedisUtlis.get(uid + "").equals(token)) {
				User u = user.getUser(uid);
				json.put("data", user.getUserData(u.getId()).getJSONObject("data"));
				json.put("msg", UserEnum.LOGIN_SUCCESS.msg);
				json.put("code", UserEnum.LOGIN_SUCCESS.code);
			}
		}
		return json.toString();
	}
	@RequestMapping("update.do")
	@ResponseBody
	public String update(HttpServletRequest request,String token) {
		JSONObject json = new JSONObject();
		User u=user.getUser(Tools.getUidOfToken(request));
		if(u==null) {
			json.put("code", UserEnum.LOGIN_NOT_LOGIN.code);
			json.put("msg", UserEnum.LOGIN_NOT_LOGIN.msg);
			return json.toString();
		}
		UUserdata udata=user.getUUserData(u.getId());
		String email=request.getParameter("email");
		String uname=request.getParameter("uname");
		String img=request.getParameter("img");
		if(email!=null) {
			udata.setEmail(email);
			user.updateUserData(udata);
		}
		if(uname!=null) {
			u.setUname(uname);
			user.updateUser(u);
		}
		if(img!=null) {
			udata.setImage(img);
			user.updateUserData(udata);
		}
		json.put("msg", "更新成功");
		json.put("code", UserEnum.LOGIN_SUCCESS.code);
		return json.toString();
	}
	@RequestMapping("img.do")
	@ResponseBody
	public String getImgToken(HttpServletRequest request) {
		JSONObject json = new JSONObject();
		int id = Tools.getUidOfToken(request);
		if(id>0) {
			String token=QiniuTools.init().getQiniuToken();
			RedisUtlis.set(token, "uimg", 10*60*1000);
			json.put("token", token);
		}
		json.put("msg", "成功");
		json.put("code", UserEnum.LOGIN_SUCCESS.code);
		return json.toString();
	}
	
	@ModelAttribute
	public void test(HttpServletRequest request, String token, String uid) {
		if (RedisUtlis.exists(uid, token)) {
			request.setAttribute("loginState", true);
		} else {
			request.setAttribute("loginState", false);
		}
	}

	@RequestMapping("test.do")
	@ResponseBody
	public String testLogin(HttpServletRequest request, String token) {
		int id = 0;
		JSONObject json = new JSONObject();
		try {
			id = Tools.getUidOfToken(request);
			if (id > 0) {
				json.put("state", request.getAttribute("loginState"));
				json.put("msg", UserEnum.LOGIN_SUCCESS.msg);
				json.put("code", UserEnum.LOGIN_SUCCESS.code);
				json.put("data", user.getUserData(id));
			}else {
				json.put("state", request.getAttribute("loginState"));
				json.put("msg", "登录信息失效");
				json.put("code", 101);
			}
			if(Tools.getUserBen(user.getUUserData(id))){
				json.put("state", false);
				json.put("msg", UserEnum.LOGIN_BEAN.msg + "" + user.getUUserData(id).getUnbeantime());
				json.put("code", UserEnum.LOGIN_BEAN.code);
			}
		} catch (Exception e) {
			// TODO: handle exception
			json.put("state", request.getAttribute("loginState"));
			json.put("msg", "登录信息失效");
			json.put("code", 101);
		}
		return json.toString();
	}
	

}
