package com.yutou.jianrdb.Dao;

import com.yutou.jianrdb.Bean.GameInfoLog;
import com.yutou.jianrdb.Bean.MapNode;
import com.yutou.maptop.Bean.UserTeam;
import com.yutou.mybatis.ZsShipType;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.beans.factory.annotation.Qualifier;

import java.util.List;

@Qualifier("db2SqlSessionTemplate")
public interface MapNodeDao {
    @Select("select * from zs_node_info where id=#{node}")
    MapNode selectNodeByNode(@Param("node")int node);

    @Select("select  distinct  level_name  from zs_node_info;")
    List<String> selectMapName();

    @Select("select  distinct  chapter_name  from zs_node_info where  level_name=#{name};")
    List<String> selectNodeName(@Param("name")String name);

    @Select("SELECT * FROM jrmbdb.zs_node_info where chapter_name=#{chapterName} and level_name=#{lievelName};")
    List<MapNode> selectMapByNode(@Param("chapterName")String chapterName,@Param("lievelName")String levelName);

    @Select("SELECT * FROM jrmbdb.game_info_log where `type`='DealNode' and ext like '%pve%' and message like '%warReport%'  and ext like #{nid} order by id desc limit #{limit},#{count};")
    List<GameInfoLog> selectNodeByMid(@Param("nid")String nodeId, @Param("limit")int limit, @Param("count")int count);

    @Select("SELECT * FROM jrmbdb.zs_ship_type;")
    List<ZsShipType> selectAllShipType();
}
