package com.yutou.maptop.Dao;

import com.yutou.maptop.Bean.MapTop;
import org.apache.ibatis.annotations.*;

import java.util.List;

public interface MapDao {
    /**
       根据mapid来查询
        接口
     */
    @Select("select * from maptop where mapId=#{mapId}  order by mapNode  limit #{limit},#{count}")
    List<MapTop> selectMapByMapId(@Param("mapId")int mapId,@Param("limit") int limit,@Param("count")int count);

    @Insert("insert into maptop(mapId,mapNode,shipTeam) values(#{mapId},#{mapNode},#{shipTeam})")
    @Options(useGeneratedKeys = true,keyProperty = "id",keyColumn = "id")
    int insertMapTop(MapTop top);

    @Select("select count(id) from maptop where mapId=#{mapId} and mapNode=#{mapNode}")
    int checkMap(MapTop top);

    @Select("select id from maptop order by id desc limit 1,1")
    int getDescId();

    /**
     * 获取完全条件
     */
    @Select("select * from maptop where mapId=#{mapId} and mapNode=#{mapNode} and shipTeam=#{shipTeam}")
    MapTop selectMapByData(@Param("mapId")int mapId,@Param("mapNode")int mapNode,@Param("shipTeam")String shipTeam);

    /**
     * 全部数据
     */
    @Select("select * from maptop order by mapNode  limit #{limit},#{count}")
    List<MapTop> selectMap(@Param("limit") int limit,@Param("count")int count);

}
