package com.yutou.maptop.Dao;

import com.yutou.maptop.Bean.UserTeam;
import org.apache.ibatis.annotations.*;

import java.util.List;

public interface UserTeamDao {
    /**
     * 根据具体节点来查询详细列表
     * @param mapNode 具体节点
     */
    @Select("select userTeam.* from userTeam INNER  join maptop as map on  userTeam.mid=map.id where map.mapNode=#{mapid} order by id desc limit #{limit},#{count}")
    List<UserTeam> selectTeamByMapId(@Param("mapid") int mapNode,@Param("limit") int limit,@Param("count")int count);

    /**
     *  根据具体节点及筛选包含类型列表
     */
    @Select("select userTeam.* from userTeam INNER  join maptop as map on  userTeam.mid=map.id where map.mapNode=#{mapnode} and map.shipTeam like #{llike} or shipTeam like #{like} or shipTeam like #{rlike}  order by id desc limit #{limit},#{count}")
    List<UserTeam> selectByMapIdAndTeamLike(@Param("mapnode")int mapnode,@Param("llike")String llike,@Param("like")String like,@Param("rlike")String rlike,@Param("limit") int limit,@Param("count")int count);

    /**
     * 根据mapTop的id来获取列表
     */
    @Select(" select userTeam.* from userTeam INNER  join maptop as map on  userTeam.mid=map.id where map.id=#{id} order by id desc limit #{limit},#{count}")
    List<UserTeam> selectByMapTopId(@Param("id")int id,@Param("limit") int limit,@Param("count")int count);

    @Insert("insert into userTeam(uname,ship,createTime,mid,mapNode,title) values(#{uname},#{ship},#{createTime},#{mid},#{mapNode},#{title})")
    void insertTeam( UserTeam param);

    @Select("select count(id) from userTeam where uname=#{uname} and ship=#{ship} and mapNode=#{mapNode}")
    int checkData(UserTeam userTeam);


    @Delete("delete from userTeam")
    void deleteData();
    @Delete("DELETE FROM sqlite_sequence WHERE name = 'userTeam'")
    void clear();


}
