package com.yutou.maptop.services;

import com.alibaba.fastjson.JSONArray;
import com.yutou.jianrdb.Dao.MapNodeDao;
import com.yutou.maptop.Bean.MapTop;
import com.yutou.maptop.Dao.MapDao;
import com.yutou.mybatis.dao.ZsShipTypeMapper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class MapTopService {
    @Resource
    MapDao mapDao;
    @Resource
    MapNodeDao nodeDao;
    @Resource
    ZsShipTypeMapper shipTypeMapper;

    public List<MapTop> selectMapByMapId(int mapId, int limit, int count) {
        List<MapTop> list=mapDao.selectMapByMapId(mapId, limit, count);
        return getMapTops(list);
    }

    public List<MapTop> selectMap(int limit,int count){
        List<MapTop> list=mapDao.selectMap(limit, count);
        return getMapTops(list);
    }

    private List<MapTop> getMapTops(List<MapTop> list) {
        for (MapTop mapTop : list) {
            mapTop.setNode(nodeDao.selectNodeByNode(mapTop.getMapNode()));
            String tmp=mapTop.getShipTeam().replace("[","");
            tmp=tmp.replace("]","");
            String[] shipType=tmp.split(",");
            String stype="";
            Map<String,Integer> types=new HashMap<>();
            for (String type : shipType) {
                if (types.containsKey(type)) {
                    types.put(type, types.get(type) + 1);
                } else {
                    types.put(type, 1);
                }

            }
            for (String key : types.keySet()) {
                try {
                    stype+=types.get(key)+shipTypeMapper.selectByPrimaryKey(Integer.parseInt(key)).getShortname()+",";
                }catch (Exception e){
                    e.printStackTrace();
                }

            }
            stype = stype.substring(0, stype.length() - 1);
            mapTop.setShipTeamTo(stype);
        }
        return list;
    }

    public int insertMapTop(MapTop top) {
        int id=0;
        MapTop old=mapDao.selectMapByData(top.getMapid(),top.getMapNode(),top.getShipTeam());
        if(old!=null){//检测到有对应的map数据，返回id
            return old.getId();
        }else{
            mapDao.insertMapTop(top);
            try {
                id=mapDao.getDescId();//获取最后的id
            }catch (Exception ignored){

            }

            id+=1;
        }
        return id;
    }



}
