package com.yutou.maptop.services;

import com.alibaba.fastjson.JSONArray;
import com.yutou.maptop.Bean.UserTeam;
import com.yutou.maptop.Dao.UserTeamDao;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service
public class UserTeamService {
    @Resource
    UserTeamDao dao;

    public void insertTeam(UserTeam team) {
        dao.insertTeam(team);
    }

    public boolean checkData(String uname, int mapId, String ship) {
        if (ship == null)
            return true;
        UserTeam team = new UserTeam();
        team.setUname(uname);
        team.setMapNode(mapId);
        team.setShip(ship);
        return dao.checkData(team) > 0;
    }

    public void clear() {
        dao.deleteData();
        dao.clear();
    }
    public List<UserTeam> searchType(int mapnode, JSONArray like, int limit, int count){
        String likesql="";
        for (Object o : like) {
            likesql+=(String)o+",";
        }
        likesql=likesql.substring(0,likesql.length()-1)+"";
        return dao.selectByMapIdAndTeamLike(mapnode,"["+likesql+",%","%,"+likesql+",%","%,"+likesql+"]",limit,count);
    }
    public List<UserTeam> searchMapNode(int mapnode, int limit, int count){
        return dao.selectTeamByMapId(mapnode,limit,count);
    }
    public List<UserTeam> selectByMapTopId(int id, int limit, int count){
        return dao.selectByMapTopId(id,limit,count);
    }
}
