package com.yutou.services.impl;

import java.util.Collections;
import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import com.yutou.mybatis.MAppHome;
import com.yutou.mybatis.MAppHomeConfig;
import com.yutou.mybatis.MAppHomeConfigExample;
import com.yutou.mybatis.MAppHomeExample;
import com.yutou.mybatis.MAppMg;
import com.yutou.mybatis.MAppMgExample;
import com.yutou.mybatis.MAppTools;
import com.yutou.mybatis.MAppToolsExample;
import com.yutou.mybatis.MGamePackname;
import com.yutou.mybatis.MGamePacknameExample;
import com.yutou.mybatis.SConfig;
import com.yutou.mybatis.User;
import com.yutou.mybatis.dao.MAppHomeConfigMapper;
import com.yutou.mybatis.dao.MAppHomeMapper;
import com.yutou.mybatis.dao.MAppMgMapper;
import com.yutou.mybatis.dao.MAppToolsMapper;
import com.yutou.mybatis.dao.MGamePacknameMapper;
import com.yutou.mybatis.dao.SConfigMapper;
import com.yutou.mybatis.dao.UserMapper;
import com.yutou.services.AppConfig;
import com.yutou.utlis.ListComparator;

@Service("appConfig")
public class AppConfigServiceImpl implements AppConfig {
	@Resource
	SConfigMapper configMapper;
	@Resource
	MAppHomeMapper appHomeMapper;
	@Resource
	MAppMgMapper appMgMapper;
	@Resource
	MGamePacknameMapper packNameMapper;
	@Resource
	MAppToolsMapper toolsMapper;
	@Resource
	MAppHomeConfigMapper appHomeConfig;
	@Resource
	UserMapper userMapper;
	
	@Override
	public int setAppConfig(SConfig config) {
		// TODO Auto-generated method stub
		return configMapper.updateByPrimaryKey(config);
	}

	@Override
	public SConfig getConfig(int id) {
		// TODO Auto-generated method stub
		return configMapper.selectByPrimaryKey(id);
	}

	@Override
	public List<MAppHome> getHomeList(boolean all) {
		// TODO Auto-generated method stub
		MAppHomeExample example=new MAppHomeExample();
		if(!all)
		example.createCriteria().andIsshowEqualTo(1);
		List<MAppHome> list=appHomeMapper.selectByExample(example);
		Collections.sort(list, new ListComparator());
		return list;
	}

	@Override
	public List<MAppMg> getMgList(boolean all) {
		// TODO Auto-generated method stub
		MAppMgExample example=new MAppMgExample();
		if(!all)
		example.createCriteria().andIsshowEqualTo(1);
		List<MAppMg>list=appMgMapper.selectByExample(example);
		Collections.sort(list, new ListComparator());
		return list;
	}

	@Override
	public int setHome(MAppHome appHome) {
		// TODO Auto-generated method stub
		return appHomeMapper.updateByPrimaryKey(appHome);
	}

	@Override
	public int addHome(MAppHome appHome) {
		// TODO Auto-generated method stub
		return appHomeMapper.insert(appHome);
	}

	@Override
	public int setMgList(MAppMg appMg) {
		// TODO Auto-generated method stub
		return appMgMapper.updateByPrimaryKey(appMg);
	}

	@Override
	public int addMgList(MAppMg appMg) {
		// TODO Auto-generated method stub
		return appMgMapper.insert(appMg);
	}

	@Override
	public List<MGamePackname> getPackNames(boolean all) {
		// TODO Auto-generated method stub
		MGamePacknameExample example=new MGamePacknameExample();
		if(!all) {
			example.createCriteria().andIsshowEqualTo(1);
		}
		List<MGamePackname> list=packNameMapper.selectByExample(example);
		return list;
	}

	@Override
	public int addPackName(MGamePackname gamePack) {
		// TODO Auto-generated method stub
		return packNameMapper.insert(gamePack);
	}

	@Override
	public int setPackName(MGamePackname gamePack) {
		// TODO Auto-generated method stub
		return packNameMapper.updateByPrimaryKey(gamePack);
	}

	@Override
	public List<MAppTools> getTools(String uid,String version) {
		// TODO Auto-generated method stub
		User user=userMapper.selectByPrimaryKey(Integer.valueOf(uid));
		int power=0;
		if(user!=null) {
			power=user.getPower();
		}
		MAppToolsExample example=new MAppToolsExample();
		example.createCriteria().andIsshowEqualTo(1).andPermissionLessThan(power).andVersionLessThanOrEqualTo(version);
		return toolsMapper.selectByExample(example);
	}

	@Override
	public List<MAppHomeConfig> getAppHomeConfig() {
		// TODO Auto-generated method stub
		MAppHomeConfigExample example=new MAppHomeConfigExample();
		//example.createCriteria().andStateGreaterThan(0);
		List<MAppHomeConfig> list=appHomeConfig.selectByExample(example);
		return list;
	}
	
}
