package com.yutou.services.impl;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import javax.annotation.Resource;

import com.yutou.utlis.Log;
import org.json.JSONObject;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSON;
import com.yutou.enums.UserPower;
import com.yutou.mybatis.TMod;
import com.yutou.mybatis.TModExample;
import com.yutou.mybatis.TModcomment;
import com.yutou.mybatis.TModcommentExample;
import com.yutou.mybatis.TModdownload;
import com.yutou.mybatis.TModdownloadExample;
import com.yutou.mybatis.TModfile;
import com.yutou.mybatis.TModfileExample;
import com.yutou.mybatis.TModfilePath;
import com.yutou.mybatis.TModfilePathExample;
import com.yutou.mybatis.TModpower;
import com.yutou.mybatis.TModpowerExample;
import com.yutou.mybatis.TModtag;
import com.yutou.mybatis.TModtagExample;
import com.yutou.mybatis.TModtypeExample;
import com.yutou.mybatis.UUsercollection;
import com.yutou.mybatis.UUsercollectionExample;
import com.yutou.mybatis.ZsShipTypeExample;
import com.yutou.mybatis.dao.TGameVersionMapper;
import com.yutou.mybatis.dao.TModMapper;
import com.yutou.mybatis.dao.TModcommentMapper;
import com.yutou.mybatis.dao.TModdownloadMapper;
import com.yutou.mybatis.dao.TModfileMapper;
import com.yutou.mybatis.dao.TModfilePathMapper;
import com.yutou.mybatis.dao.TModpowerMapper;
import com.yutou.mybatis.dao.TModtagMapper;
import com.yutou.mybatis.dao.TModtypeMapper;
import com.yutou.mybatis.dao.UUsercollectionMapper;
import com.yutou.mybatis.dao.ZsShipTypeMapper;
import com.yutou.services.ModService;
import com.yutou.utlis.Tools;

@Service("modService")
public class ModServiceimpl implements ModService {
	@Resource
	TModMapper modMapper;
	@Resource
	TModcommentMapper modcommentMapper;
	@Resource
	TModfileMapper modfileMapper;
	@Resource
	TModfilePathMapper modfilePathMapper;
	@Resource
	TGameVersionMapper gameVersionMapper;
	@Resource
	TModtagMapper tagMapper;
	@Resource
	TModpowerMapper modPowerMapper;
	@Resource
	TModdownloadMapper modDownloadMapper;
	@Resource
	TModtypeMapper modTypeMapper;
	@Resource
	ZsShipTypeMapper jianTypeMapper;
	@Resource
	UUsercollectionMapper conllectionMapper;
	
	
	@Override
	public int upload(JSONObject json) {
		// TODO Auto-generated method stub
		try {
			Log.i("提交数据库："+json.toString());
			TMod mod = JSON.parseObject(json.toString(), TMod.class);
			mod.setCreatetime(System.currentTimeMillis());
			mod.setIcon(json.getString("icon"));
			mod.setModversion(1);
			mod.setModname(mod.getModtype() + "_" + (modMapper.selectByExample(new TModExample()).size() + 1));
			int remod=0;
			try {
				remod=Integer.valueOf(json.getString("remod"));
			} catch (Exception e) {
				// TODO: handle exception
			}
			mod.setRemod(remod);
			modMapper.insert(mod);
			
			for (int i = 0; i < json.getJSONArray("files").length(); i++) {
				JSONObject files = json.getJSONArray("files").getJSONObject(i);
				TModfile filePath = new TModfile();
				filePath.setMid(mod.getId());
				filePath.setServiceurl(files.getString("url"));
				filePath.setFilename(files.getString("name"));
				if (Tools.StringIsEmpty(files.getString("path"))) {
					filePath.setInstallpathid(json.getInt("installPath")+"");
				} else {
					filePath.setInstallpathid(files.getInt("path")+"");
				}
				filePath.setCreatetime(System.currentTimeMillis());
				modfileMapper.insert(filePath);
			}

			TModtag tag = new TModtag();
			tag.setMid(mod.getId());
			tag.setTag(json.getString("tag"));
			tagMapper.insert(tag);
			
			TModpower modpower=new TModpower();
			modpower.setMid(mod.getId());
			modpower.setPower("0");
			modpower.setPoweruser("system");
			modpower.setCreatetime(System.currentTimeMillis());
			modPowerMapper.insert(modpower);
			
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
			return 0;
		}
		return 1;
	}
	
	@Override
	public TMod getMod(int id,int upower) {
		// TODO Auto-generated method stub
		TMod mod=modMapper.selectByPrimaryKey(id);
		if(mod==null)
			return null;
		if(upower<UserPower.Power.U_Auditor.code&&getModPower(mod.getId()).getPower().equals("0")) {
			return null;
		}
		return mod;
	}
	@Override
	public List<TMod> getMod(String search,int upower) {
		// TODO Auto-generated method stub
		List<TMod> mods=new ArrayList<>();
		List<TModtag> tags=new ArrayList<>();
		TModExample modExample=new TModExample();
		TModtagExample tagExample=new TModtagExample();
		modExample.createCriteria().andTitleLike("%"+search+"%");
		tagExample.createCriteria().andTagLike("%"+search+"%");
		mods=modMapper.selectByExample(modExample);
		tags=tagMapper.selectByExample(tagExample);
		for (TModtag tag : tags) {
			TMod mod=modMapper.selectByPrimaryKey(tag.getMid());
			if(!mods.contains(mod)) {
				mods.add(mod);
			}
		}
		for(int i=0;i<mods.size();i++) {
			if(upower<UserPower.Power.U_Auditor.code&&getModPower(mods.get(i).getId()).getPower().equals("0")) {
				mods.set(i, null);
			}
		}
		mods.removeAll(Collections.singleton(null));
		return mods;
	}

	@Override
	public List<TModcomment> getModComment(int mid) {
		// TODO Auto-generated method stub
		TModcommentExample example=new TModcommentExample();
		example.createCriteria().andMidEqualTo(mid);
		List<TModcomment> list=modcommentMapper.selectByExample(example);
		return list;
	}

	@Override
	public int getModDownload(int mid) {
		// TODO Auto-generated method stub
		TModdownloadExample example=new TModdownloadExample();
		example.createCriteria().andMidEqualTo(mid);
		List<TModdownload> list=modDownloadMapper.selectByExample(example);
		return list.size();
	}

	@Override
	public List<TModfile> getModFile(int mid,int uid) {
		// TODO Auto-generated method stub
		TModfileExample example=new TModfileExample();
		example.createCriteria().andMidEqualTo(mid);
		List<TModfile> list=modfileMapper.selectByExample(example);
		for (TModfile tModfile : list) {
			TModfilePath filePath=modfilePathMapper.selectByPrimaryKey(Integer.valueOf(tModfile.getInstallpathid()));
			tModfile.setInstallpathid(filePath.getPath());
		}
		TModdownload download=new TModdownload();
		download.setMid(mid);
		download.setUid(uid);
		modDownloadMapper.insert(download);
		return list;
	}

	@Override
	public String getPath(int id) {
		// TODO Auto-generated method stub
		TModfilePath path=modfilePathMapper.selectByPrimaryKey(id);
		if(path!=null) {
			return path.getPath();
		}
		return null;
	}

	@Override
	public List<TMod> getMods(int min, int max,int upower) {
		// TODO Auto-generated method stub
		TModExample modExample=new TModExample();
		if(min!=-1&&max!=-1) {
			modExample.createCriteria().andIdBetween(min, max);
		}
		List<TMod> list=modMapper.selectByExample(modExample);
		for(int i=0;i<list.size();i++) {
			if(upower<UserPower.Power.U_Auditor.code&&getModPower(list.get(i).getId()).getPower().equals("0")) {
				list.set(i, null);
			}
		}
		list.removeAll(Collections.singleton(null));
		return list;
	}

	@Override
	public TModpower getModPower(int mid) {
		// TODO Auto-generated method stub
		TModpowerExample example=new TModpowerExample();
		example.createCriteria().andMidEqualTo(mid);
		List<TModpower> list=modPowerMapper.selectByExample(example);
		TModpower power=null;
		if(list.size()>0)
			power=list.get(0);
		return power;
	}
	@Override
	public List<TMod> getTypeOfMod(int tid){
		List<TMod> list=new ArrayList<>();
		TModExample modExample=new TModExample();
		modExample.createCriteria().andModtypeEqualTo(tid+"");
		list=modMapper.selectByExample(modExample);
		for(int i=0;i<list.size();i++) {
			if(getModPower(list.get(i).getId()).getPower().equals("0")) {
				list.set(i, null);
			}
		}
		list.removeAll(Collections.singleton(null));
		return list;
	}
	@Override
	public List<TMod> getTypeOfJian(int tid){
		List<TMod> list=new ArrayList<>();
		TModExample modExample=new TModExample();
		modExample.createCriteria().andJianrtypeEqualTo(tid+"");
		list=modMapper.selectByExample(modExample);
		for(int i=0;i<list.size();i++) {
			if(getModPower(list.get(i).getId()).getPower().equals("0")) {
				list.set(i, null);
			}
		}
		list.removeAll(Collections.singleton(null));
		return list;
	}
	@Override
	public List<TMod> getUserOfId(int uid){
		TModExample example=new TModExample();
		example.createCriteria().andByidEqualTo(uid);
		List<TMod> list=modMapper.selectByExample(example);
		for(int i=0;i<list.size();i++) {
			if(getModPower(list.get(i).getId()).getPower().equals("0")) {
				list.set(i, null);
			}
		}
		list.removeAll(Collections.singleton(null));
		return list;
	}

	@Override
	public List<TMod> getReMod(int mid,int remid) {
		// TODO Auto-generated method stub
		TModExample example=new TModExample();
		if(remid==0) {
			example.createCriteria().andRemodEqualTo(mid);
		}else {
			example.createCriteria().andIdEqualTo(remid);
		}
		List<TMod> list=modMapper.selectByExample(example);
		for(int i=0;i<list.size();i++) {
			if(getModPower(list.get(i).getId()).getPower().equals("0")) {
				list.set(i, null);
			}
		}
		list.removeAll(Collections.singleton(null));
		return list;
	}

	@Override
	public List<TModtag> getModTag(int mid) {
		// TODO Auto-generated method stub
		TModtagExample example=new TModtagExample();
		example.createCriteria().andMidEqualTo(mid);
		TModtag tag=tagMapper.selectByExample(example).get(0);
		List<TModtag> tags=new ArrayList<>();
		for(int i=0;i<tag.getTag().split(";").length;i++) {
			TModtag tmp=tag.clone();
			tmp.setTag(tag.getTag().split(";")[i]);
			tags.add(tmp);
		}
		return tags;
	}

	@Override
	public int setConllection(String uid, String mid) {
		// TODO Auto-generated method stub
		int _uid=0;
		int _mid=0;
		try {
			_uid=Integer.valueOf(uid);
			
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
			try {
				if(uid.contains(",")) {
					_uid=Integer.valueOf(uid.split(",")[0]);
				}else {
					return 0;
				}
			} catch (Exception e2) {
				// TODO: handle exception
				e2.printStackTrace();
				return 0;
			}
			
			
		}
		try {
			_mid=Integer.valueOf(mid);
		} catch (Exception e) {
			// TODO: handle exception
			return 0;
		}
		UUsercollectionExample example=new UUsercollectionExample();
		example.createCriteria().andUidEqualTo(_uid).andMidEqualTo(_mid);
		if(conllectionMapper.selectByExample(example).size()>0){
			return -1;
		}
		UUsercollection usercollection=new UUsercollection();
		usercollection.setUid(_uid);
		usercollection.setMid(_mid);
		usercollection.setCreatetime(System.currentTimeMillis());
		return conllectionMapper.insert(usercollection);
	}

	@Override
	public int setModPower(int mid, int power) {
		// TODO Auto-generated method stub
		TModpowerExample example=new TModpowerExample();
		example.createCriteria().andMidEqualTo(mid);
		List<TModpower> mods=modPowerMapper.selectByExample(example);
		if(mods.isEmpty()) {
			return 0;
		}
		TModpower mpower=mods.get(0);
		mpower.setPower(power+"");
		int i=modPowerMapper.updateByPrimaryKey(mpower);
		return i;
	}

	@Override
	public int moveMod(int mid, String jType, String mType) {
		// TODO Auto-generated method stub
		TMod mod=modMapper.selectByPrimaryKey(mid);
		if(mod==null)
			return 0;
		mod.setJianrtype(jType);
		mod.setModtype(mType);
		int i=modMapper.updateByPrimaryKey(mod);
		return i;
	}

	@Override
	public JSONObject getTypeInfo() {
		// TODO Auto-generated method stub
		JSONObject json=new JSONObject();
		json.put("mType", JSON.toJSON(modTypeMapper.selectByExample(new TModtypeExample())));
		json.put("jType", JSON.toJSON(jianTypeMapper.selectByExample(new ZsShipTypeExample())));
		return json;
	}

	@Override
	public List<TModfilePath> getInstallPaths() {
		// TODO Auto-generated method stub
		List<TModfilePath> path=modfilePathMapper.selectByExample(new TModfilePathExample());
		return path;
	}
}
