package com.yutou.services.impl;

import java.util.Date;
import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import com.yutou.mybatis.UGroup;
import com.yutou.mybatis.UGroupExample;
import com.yutou.mybatis.UUserdata;
import com.yutou.mybatis.User;
import com.yutou.mybatis.dao.UGroupMapper;
import com.yutou.mybatis.dao.UUserdataMapper;
import com.yutou.mybatis.dao.UserMapper;
import com.yutou.services.PermissionService;

@Service("permissionService")
public class PermissionServiceImpl implements PermissionService {
	@Resource
	UGroupMapper groupMapper;
	@Resource
	UserMapper userMapper;
	@Resource
	UUserdataMapper userdataMapper;

	@Override

	public List<UGroup> getGroup() {
		// TODO Auto-generated method stub
		UGroupExample example = new UGroupExample();
		example.createCriteria();
		return groupMapper.selectByExample(example);
	}

	@Override
	public UGroup getGroup(String title) {
		UGroupExample example = new UGroupExample();
		example.createCriteria().andTitleLike(title);
		try {
			return groupMapper.selectByExample(example).get(0);
		} catch (Exception e) {
			// TODO: handle exception
		}
		return null;
	}

	@Override
	public UGroup getGroup(int power, UGroup group) {
		// TODO Auto-generated method stub
		UGroupExample example = new UGroupExample();
		if (group != null) {
			example.createCriteria().andPermissionLessThanOrEqualTo(power).andTitleEqualTo(group.getTitle());
		} else {
			example.createCriteria().andPermissionEqualTo(power);
		}
		try {
			return groupMapper.selectByExample(example).get(0);
		} catch (Exception e) {
			// TODO: handle exception
		}
		return null;
	}

	@Override
	public int benUser(int muid, int uid, Date time) {
		// TODO Auto-generated method stub
		try {
			User admin = userMapper.selectByPrimaryKey(muid);
			User user = userMapper.selectByPrimaryKey(uid);
			if (admin.getPower() >= getGroup("管理员").getPermission()) {
				UUserdata data = userdataMapper.selectByPrimaryKey(user.getId());
				data.setUnbeantime(time);
				data.setBeantime(new Date());
				userdataMapper.updateByPrimaryKey(data);
				return 1;
			}
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		return 0;
	}

	@Override
	public int unBenUser(int muid, int uid) {
		// TODO Auto-generated method stub
		try {
			User admin = userMapper.selectByPrimaryKey(muid);
			User user = userMapper.selectByPrimaryKey(uid);
			if (admin.getPower() >= getGroup("管理员").getPermission()) {
				UUserdata data = userdataMapper.selectByPrimaryKey(user.getId());
				data.setUnbeantime(new Date());
				userdataMapper.updateByPrimaryKey(data);
				return 1;
			}
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		return 0;
	}

}
