package com.yutou.services.impl;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import com.yutou.enums.UserPower;
import com.yutou.mybatis.MAppPlugs;
import com.yutou.mybatis.MAppPlugsExample;
import com.yutou.mybatis.UDevUser;
import com.yutou.mybatis.UDevUserExample;
import com.yutou.mybatis.dao.MAppPlugsMapper;
import com.yutou.mybatis.dao.UDevUserMapper;
import com.yutou.mybatis.dao.UserMapper;
import com.yutou.services.PlugsService;

@Service("plugsService")
public class PlugsServiceImpl implements PlugsService {
	@Resource
	MAppPlugsMapper plugMapper;
	@Resource
	UDevUserMapper devMapper;
	@Resource
	UserMapper userMapper;
	
	@Override
	public List<MAppPlugs> getPlugs(int power) {
		// TODO Auto-generated method stub
		MAppPlugsExample example=new MAppPlugsExample();
		if(isPower(power)) {
			example.createCriteria().andPlugshowEqualTo(1);
		}
		return plugMapper.selectByExample(example);
	}

	@Override
	public MAppPlugs getPlug(int power,int id) {
		// TODO Auto-generated method stub
		MAppPlugs plug=plugMapper.selectByPrimaryKey(id);
		if(plug==null)
			return null;
		if(isPower(power)&&plug.getPlugshow()==0) {
			return null;
		}
		return plug;
	}

	@Override
	public boolean addPlug(MAppPlugs plug) {
		// TODO Auto-generated method stub
		return plugMapper.insert(plug)==1;
	}

	@Override
	public boolean removePlug(int id) {
		// TODO Auto-generated method stub
		return plugMapper.deleteByPrimaryKey(id)==1;
	}
	private boolean isPower(int power) {
		return power<UserPower.Power.ADMIN.code;
	}

	@Override
	public UDevUser checkPlugs(String appid, String md5, String fileName) {
		// TODO Auto-generated method stub
		try {
			MAppPlugsExample plugExample=new MAppPlugsExample();
			plugExample.createCriteria().andFilenameEqualTo(fileName).andMd5EqualTo(md5).andPlugshowEqualTo(1);
			MAppPlugs plugin=plugMapper.selectByExample(plugExample).get(0);
			
			UDevUserExample devUserExample=new UDevUserExample();
			devUserExample.createCriteria().andAppidEqualTo(appid).andIdEqualTo(plugin.getDevid());
			UDevUser devUser=devMapper.selectByExample(devUserExample).get(0);
			return devUser;
		}catch (Exception e) {
			// TODO: handle exception
		}
		return null;
	}
}
