package com.yutou.services.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.annotation.Resource;

import org.json.JSONObject;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.yutou.mybatis.TMod;
import com.yutou.mybatis.UUserGameData;
import com.yutou.mybatis.UUserGameDataExample;
import com.yutou.mybatis.UUsercollection;
import com.yutou.mybatis.UUsercollectionExample;
import com.yutou.mybatis.UUserdata;
import com.yutou.mybatis.UUserdataExample;
import com.yutou.mybatis.User;
import com.yutou.mybatis.UserExample;
import com.yutou.mybatis.dao.TModMapper;
import com.yutou.mybatis.dao.UUserGameDataMapper;
import com.yutou.mybatis.dao.UUsercollectionMapper;
import com.yutou.mybatis.dao.UUserdataMapper;
import com.yutou.mybatis.dao.UserMapper;
import com.yutou.services.UserService;

@Service("userService")
public class UserServiceimpl implements UserService{
	@Resource
	UserMapper userMapper;
	@Resource
	UUserdataMapper userDataMapper;
	@Resource
	UUsercollectionMapper userCollectionMapper;
	@Resource
	TModMapper modMapper;
	@Resource
	UUserGameDataMapper uGameData;
	
	@Override
	public int login(String uname, String pass) {
		// TODO Auto-generated method stub
		UserExample example=new UserExample();
		example.createCriteria().andNameEqualTo(uname).andPassEqualTo(pass);
		User user;
		try {
			user=userMapper.selectByExample(example).get(0);
		} catch (Exception e) {
			// TODO: handle exception
			example.clear();
			example.createCriteria().andNameEqualTo(uname);
			try {
				userMapper.selectByExample(example).get(0);
			} catch (Exception e2) {
				// TODO: handle exception
				return -1; //未注册
			}
			return -2; //密码错误
		}
		if(user.getPower()==-1) {
			return -4; //永久禁止登陆
		}
		UUserdata udata=getUUserData(user.getId());
		if(udata.getUnbeantime()!=null) {
			if(udata.getUnbeantime().getTime()>System.currentTimeMillis()) {
				return -3; //被ban了（带解封时间）
			}
		}
		
		return user.getId();
		
	}
	@Override
	public int getUserId(String uname) {
		// TODO Auto-generated method stub
		UserExample example=new UserExample();
		example.createCriteria().andNameEqualTo(uname);
		User user;
		try {
			user=userMapper.selectByExample(example).get(0);
		} catch (Exception e) {
			// TODO: handle exception
			example.clear();
			example.createCriteria().andNameEqualTo(uname);
			try {
				userMapper.selectByExample(example).get(0);
			} catch (Exception e2) {
				// TODO: handle exception
				return -1; //未注册
			}
			return -2; //密码错误
		}
		return user.getId();
	}
	@Override
	public int reg(String uname,String name, String pass) {
		// TODO Auto-generated method stub
		UserExample example=new UserExample();
		example.createCriteria().andNameEqualTo(uname);
		User user;
		try {
			user=userMapper.selectByExample(example).get(0);
			return 2;
		} catch (Exception e) {
			// TODO: handle exception
		}
		user=new User();
		user.setName(uname);
		user.setPass(pass);
		user.setImei("------");
		user.setUname(name);
		user.setPower(0);
		userMapper.insert(user);
		UUserdata userdata=new UUserdata();
		userdata.setCreatetime(new Date().getTime());
		userdata.setUid(user.getId());
		userdata.setCredit(0);
		userdata.setLogintime(new Date());
		userDataMapper.insert(userdata);
		
		return user.getId();
	}

	@Override
	public int userPower(int id) {
		// TODO Auto-generated method stub
		User user=userMapper.selectByPrimaryKey(id);
		if(user==null) {
			return -1;
		}
		return user.getPower();
	}

	@Override
	public JSONObject getUserData(int id) {
		// TODO Auto-generated method stub
		JSONObject json=new JSONObject();
		User user=userMapper.selectByPrimaryKey(id);
		if(user==null) {
			json.put("code", "-1");
			json.put("msg", "没有该用户");
			return json;
		}
		user.setPass("1029384756qqwertyuiopzxcvbnm√");
		JSONObject uJson=new JSONObject();
		JSONObject dJson=new JSONObject();
		JSONArray cJson=new JSONArray();
		
		UUserdataExample example=new UUserdataExample();
		example.createCriteria().andUidEqualTo(user.getId());
		UUserdata udata=userDataMapper.selectByExample(example).get(0);
		
		UUsercollectionExample example2=new UUsercollectionExample();
		example2.createCriteria().andUidEqualTo(user.getId());
		List<UUsercollection> usercollection=userCollectionMapper.selectByExample(example2);
		
		uJson=new JSONObject(JSON.toJSONString(user));
		dJson=new JSONObject(JSON.toJSONString(udata));
		cJson=new JSONArray();
		for (UUsercollection uUsercollection : usercollection) {
			cJson.add(new JSONObject(JSON.toJSONString(uUsercollection)));
		}
		JSONObject data=new JSONObject();
		data.put("user", uJson);
		data.put("userdata", dJson);
		data.put("collection", cJson);
		json.put("data", data);
		return json;
	}

	@Override
	public User getUser(int id) {
		// TODO Auto-generated method stub
		User user=userMapper.selectByPrimaryKey(id);
		return user;
	}
	@Override
	public int addModCollect(int uid,int mid) {
		
		return 0;
	}

	@Override
	public List<TMod> userCollectMod(int min,int max,int uid) {
		// TODO Auto-generated method stub
		List<TMod> list=new ArrayList<>();
		UUsercollectionExample example=new UUsercollectionExample();
		if(max!=-1)
			example.createCriteria().andUidEqualTo(uid).andIdBetween(min, max);
		else
			example.createCriteria().andUidEqualTo(uid);
		List<UUsercollection> userCollect=userCollectionMapper.selectByExample(example);
		for (UUsercollection uUsercollection : userCollect) {
			TMod mod=modMapper.selectByPrimaryKey(uUsercollection.getMid());
			if(mod!=null)
				list.add(mod);
		}
		return list;
	}

	@Override
	public int removeCollectMod(int mid) {
		// TODO Auto-generated method stub
		int i=userCollectionMapper.deleteByPrimaryKey(mid);
		return i;
	}

	@Override
	public int updateUserData(UUserdata udata) {
		// TODO Auto-generated method stub
		int i=userDataMapper.updateByPrimaryKey(udata);
		return i;
	}

	@Override
	public UUserdata getUUserData(int id) {
		// TODO Auto-generated method stub
		UUserdataExample example=new UUserdataExample();
		example.createCriteria().andUidEqualTo(id);
		UUserdata udata=null;
		try {
			udata=userDataMapper.selectByExample(example).get(0);
		} catch (NullPointerException e) {
			// TODO: handle exception
			udata=new UUserdata();
			udata.setUid(id);
			udata.setCredit(0);
			udata.setCreatetime(System.currentTimeMillis());
			udata.setLogintime(new Date());
			userDataMapper.insert(udata);
		}
		
		return udata;
	}

	@Override
	public int updateUser(User user) {
		// TODO Auto-generated method stub
		int i=userMapper.updateByPrimaryKey(user);
		return i;
	}
	@Override
	public List<User> getUserList(int min,int max) {
		// TODO Auto-generated method stub
		UserExample example=new UserExample();
		if(min==-1) {
			
		}else {
			min--;
		example.createCriteria().andIdBetween(min*max, min*max+max);
		}
		return userMapper.selectByExample(example);
	}
	@Override
	public List<User> searchUser(String type, String key) {
		// TODO Auto-generated method stub
		UserExample example=new UserExample();
		switch (type) {
		case "uid":
			example.createCriteria().andIdEqualTo(Integer.valueOf(key));
			break;
		case "name":
			example.createCriteria().andNameLike("%"+key+"%");
			break;
		case "uname":
			example.createCriteria().andUnameLike("%"+key+"%");
			break;
		default:
			break;
		}
		return userMapper.selectByExample(example);
	}
	@Override
	public void addGameData(UUserGameData gameData) {
		// TODO Auto-generated method stub
		uGameData.insert(gameData);
	}
	@Override
	public void updateGameData(UUserGameData gameData) {
		// TODO Auto-generated method stub
		uGameData.updateByPrimaryKey(gameData);
	}
	@Override
	public List<UUserGameData> getGameData(int uid) {
		// TODO Auto-generated method stub
		UUserGameDataExample example=new UUserGameDataExample();
		example.createCriteria().andUidEqualTo(uid);
		return uGameData.selectByExample(example);
	}
	@Override
	public UUserGameData findGameData(int uid,String fileName) {
		// TODO Auto-generated method stub
		UUserGameDataExample example=new UUserGameDataExample();
		example.createCriteria().andUidEqualTo(uid).andFileEqualTo(fileName);
		List<UUserGameData> list=uGameData.selectByExample(example);
		UUserGameData data=null;
		if(list!=null&&list.size()>0)
			data=list.get(0);
		return data;
	}

}
