package com.yutou.utlis;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.yutou.Data.Ship;

import java.util.ArrayList;
import java.util.List;

public class JianrDataTools {
    public final static int SHIP_TYPE = 0;
    public final static int SHIP_TITLE = 1;
    public final static int SHIP_CID = 2;

    public static String getShip(JSONObject message, int type) {
        String ship = null;
        if(message.getJSONObject("warReport")==null){
            return null;
        }
        JSONArray array = message.getJSONObject("warReport").getJSONArray("selfShips");
        ship = "[";
        for (int i = 0; i < array.size(); i++) {
            Ship sp = Ship.getInstance(array.getJSONObject(i));
            switch (type) {
                case SHIP_CID:
                    ship += sp.getShipCid() + ",";
                    break;
                case SHIP_TITLE:
                    ship += sp.getTitle() + ",";
                    break;
                case SHIP_TYPE:
                    ship += sp.getType() + ",";
                    break;
            }

        }
        ship = ship.substring(0, ship.length() - 1) + "]";
        return ship;
    }

    public static JSONArray getShip(JSONObject message){
        JSONArray equipment = new JSONArray();
        if(message.getJSONObject("warReport").isEmpty()){
            return equipment;
        }
        JSONArray array = message.getJSONObject("warReport").getJSONArray("selfShips");
        for (int i = 0; i < array.size(); i++) {
            Ship sp = Ship.getInstance(array.getJSONObject(i));
            JSONObject item=new JSONObject();
            item.put("cid",sp.getShipCid());
            item.put("equipment", com.alibaba.fastjson.JSONArray.toJSON(sp.getEquipment()));
            item.put("level",sp.getLevel());
            equipment.add(item);
        }
        return equipment;
    }
    public static int getMapId(String ext) {
        JSONObject json = JSONObject.parseObject(ext);
        return json.getInteger("n") / 100;
    }

    public static int getMapNode(String ext) {
        JSONObject json = JSONObject.parseObject(ext);
        return json.getInteger("n");
    }
}
